<?php
// -----------------------------------------------------------------------
//
// $Id: categories.php 8 2012-01-21 09:59:39Z root $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['ADMIN_INDEX_TITLE']);

// Administrator ?
if ($users['user_level'] < 4)
{
    error_template($lang['ADMIN_LEVEL_ERROR']);
}
else
{
    // From add form ?
    if (isset($_POST['add_category']))
    {
        $error = '';
        $upload_dir = './../images/categories/';
        $upload_name = $_FILES['category_image']['name'];
        $upload_file = $upload_dir . $upload_name;
        $upload_ext = substr($upload_name, strrpos($upload_name, '.'));
        $valid_ext = array('.gif', '.GIF', '.jpg', '.JPG', '.jpeg', '.JPEG', '.png', '.PNG');
        // Check name
        if (!trim($_POST['category_name']))
        {
            $error .= $lang['NO_CATEGORY_NAME'];
        }
        else
        {
            $sql->query('SELECT category_name
                         FROM ' . TABLE_CATEGORIES . '
                         WHERE category_name = \'' . chars2entities($_POST['category_name'], ENT_QUOTES) . '\'');
            $table_categories = $sql->fetch();
            // Check duplicate name
            if ($table_categories['category_name'])
            {
                $error .= $lang['ADMIN_CATEGORIES_ERROR1'];
            }
        }
        // Check image
        if (!trim($upload_name))
        {
            $error .= $lang['NO_CATEGORY_IMAGE'];
        }
        else
        {
            // Check directory permissions
            if (!is_writable($upload_dir))
            {
                $error .= sprintf($lang['ADMIN_CATEGORIES_ERROR2'], $upload_dir);
            }
            // Check duplicate image
            if (file_exists($upload_file))
            {
                $error .= $lang['ADMIN_CATEGORIES_ERROR3'];
            }
            // Check image format
            if (!in_array($upload_ext, $valid_ext))
            {
                $error .= $lang['INVALID_IMAGE_FILE'];
            }
        }
        if ($error)
        {
            error_template($error);
        }
        else
        {
            if (move_uploaded_file($_FILES['category_image']['tmp_name'], $upload_file))
            {
                $sql->query('INSERT INTO ' . TABLE_CATEGORIES . ' (category_name, category_image, category_level)
                             VALUES (\'' . chars2entities($_POST['category_name'], ENT_QUOTES) . '\', \'' . $upload_file . '\', \'' . $_POST['category_level'] . '\')');
                success_template($lang['ADMIN_CATEGORIES_ADDED'], './../admin/advanced.php');
            }
            else
            {
                error_template($lang['ADMIN_CATEGORIES_ERROR4']);
            }
        }
    }
    // Categories list
    elseif (isset($_GET['action']) && $_GET['action'] == 'edit_categories')
    {
        $template->set_file('admin', 'admin/categories/view.htpl');
        $template->set_block('admin', 'CATEGORIES_BLOCK', 'categories');
        $sql->query('SELECT category_id, category_image, category_name
                     FROM ' . TABLE_CATEGORIES . '
                     ORDER BY category_name');
        while ($table_categories = $sql->fetch())
        {
            $template->set_var(array('CATEGORY_ID' => $table_categories['category_id'],
                                     'CATEGORY_IMAGE' => $table_categories['category_image'],
                                     'CATEGORY_NAME' => $table_categories['category_name'],
                                     'DELETE' => $lang['DELETE'],
                                     'EDIT' => $lang['EDIT']));
            $template->parse('CATEGORIES_BLOCK', 'categories', true);
        }
        $template->set_var(array('ADMIN_CATEGORIES_HEADER2' => $lang['ADMIN_CATEGORIES_HEADER2'],
                                 'BACK_ADMIN_ADVANCED' => $lang['BACK_ADMIN_ADVANCED']));
        $template->parse('admin');
    }
    // Edit form
    elseif (isset($_GET['action']) && $_GET['action'] == 'edit_category')
    {
        // Check query
        if (!empty($_GET['category_id']))
        {
            $sql->query('SELECT category_id, category_image, category_level, category_name
                         FROM ' . TABLE_CATEGORIES . '
                         WHERE category_id = \'' . $_GET['category_id'] . '\'');
            $table_categories = $sql->fetch();
            // Check category
            if (!$table_categories['category_id'])
            {
                error_template($lang['ADMIN_QUERY_ERROR']);
            }
            else
            {
                if ($table_categories['category_level'] == 0)
                {
                    $category_level_options = '<option value="0" selected="selected">' . $lang['ADMIN_CATEGORIES_LEVEL0'] . '</option><option value="1">' . $lang['ADMIN_CATEGORIES_LEVEL1'] . '</option><option value="2">' . $lang['ADMIN_CATEGORIES_LEVEL2'] . '</option><option value="3">' . $lang['ADMIN_CATEGORIES_LEVEL3'] . '</option>';
                }
                elseif ($table_categories['category_level'] == 1)
                {
                    $category_level_options = '<option value="0">' . $lang['ADMIN_CATEGORIES_LEVEL0'] . '</option><option value="1" selected="selected">' . $lang['ADMIN_CATEGORIES_LEVEL1'] . '</option><option value="2">' . $lang['ADMIN_CATEGORIES_LEVEL2'] . '</option><option value="3">' . $lang['ADMIN_CATEGORIES_LEVEL3'] . '</option>';
                }
                elseif ($table_categories['category_level'] == 2)
                {
                    $category_level_options = '<option value="0">' . $lang['ADMIN_CATEGORIES_LEVEL0'] . '</option><option value="1">' . $lang['ADMIN_CATEGORIES_LEVEL1'] . '</option><option value="2" selected="selected">' . $lang['ADMIN_CATEGORIES_LEVEL2'] . '</option><option value="3">' . $lang['ADMIN_CATEGORIES_LEVEL3'] . '</option>';
                }
                else
                {
                    $category_level_options = '<option value="0">' . $lang['ADMIN_CATEGORIES_LEVEL0'] . '</option><option value="1">' . $lang['ADMIN_CATEGORIES_LEVEL1'] . '</option><option value="2">' . $lang['ADMIN_CATEGORIES_LEVEL2'] . '</option><option value="3" selected="selected">' . $lang['ADMIN_CATEGORIES_LEVEL3'] . '</option>';
                }
                $template->set_file('admin', 'admin/categories/edit.htpl');
                $template->set_var(array('ADMIN_CATEGORIES_HEADER3' => $lang['ADMIN_CATEGORIES_HEADER3'],
                                         'BACK_ADMIN_ADVANCED' => $lang['BACK_ADMIN_ADVANCED'],
                                         'CATEGORY_ID' => $table_categories['category_id'],
                                         'CATEGORY_IMAGE' => $table_categories['category_image'],
                                         'CATEGORY_LEVEL_OPTIONS' => $category_level_options,
                                         'CATEGORY_NAME' => $table_categories['category_name'],
                                         'EDIT' => $lang['EDIT'],
                                         'FORM_CATEGORY_IMAGE' => $lang['FORM_CATEGORY_IMAGE'],
                                         'FORM_CATEGORY_LEVEL' => $lang['FORM_CATEGORY_LEVEL'],
                                         'FORM_CATEGORY_NAME' => $lang['FORM_CATEGORY_NAME'],
                                         'FORM_CURRENT_IMAGE' => $lang['FORM_CURRENT_IMAGE']));
                $template->parse('admin');
            }
        }
        else
        {
            error_template($lang['ADMIN_QUERY_ERROR']);
        }
    }
    // From edit form ?
    elseif (isset($_POST['edit_category']))
    {
        $error = '';
        $upload_dir = './../images/categories/';
        $upload_name = $_FILES['category_image2']['name'];
        $upload_file = $upload_dir . $upload_name;
        $upload_ext = substr($upload_name, strrpos($upload_name, '.'));
        $valid_ext = array('.gif', '.GIF', '.jpg', '.JPG', '.jpeg', '.JPEG', '.png', '.PNG');
        // Check name
        if (!trim($_POST['category_name']))
        {
            $error .= $lang['NO_CATEGORY_NAME'];
        }
        else
        {
            $sql->query('SELECT category_name
                         FROM ' . TABLE_CATEGORIES . '
                         WHERE category_name = \'' . chars2entities($_POST['category_name'], ENT_QUOTES) . '\'
                         AND category_id <> \'' . $_POST['category_id'] . '\'');
            $table_categories = $sql->fetch();
            // Check duplicate name
            if ($table_categories['category_name'])
            {
                $error .= $lang['ADMIN_CATEGORIES_ERROR1'];
            }
        }
        // Check new image
        if (!empty($upload_name))
        {
            // Check directory permissions
            if (!is_writable($upload_dir))
            {
                $error .= sprintf($lang['ADMIN_CATEGORIES_ERROR2'], $upload_dir);
            }
            // Check duplicate image
            if (file_exists($upload_file))
            {
                $error .= $lang['ADMIN_CATEGORIES_ERROR3'];
            }
            // Check image format
            if (!in_array($upload_ext, $valid_ext))
            {
                $error .= $lang['INVALID_IMAGE_FILE'];
            }
        }
        // Check category
        $sql->query('SELECT category_news, category_posts
                     FROM ' . TABLE_CATEGORIES . '
                     WHERE category_id = \'' . $_POST['category_id'] . '\'');
        $table_categories = $sql->fetch();
        switch ($_POST['category_level'])
        {
            case 0:
                if ($table_categories['category_posts'] != 0)
                {
                    $error .= $lang['ADMIN_CATEGORIES_ERROR5'];
                }
                break;
            case 1:
            case 3:
                if ($table_categories['category_news'] != 0)
                {
                    $error .= $lang['ADMIN_CATEGORIES_ERROR6'];
                }
                break;
        }
        if ($error)
        {
            error_template($error);
        }
        else
        {
            // New image ?
            if (!empty($upload_name))
            {
                if (move_uploaded_file($_FILES['category_image2']['tmp_name'], $upload_file))
                {
                    // Delete old image
                    unlink($_POST['category_image']);
                    $sql->query('UPDATE ' . TABLE_CATEGORIES . '
                                 SET category_name = \'' . chars2entities($_POST['category_name'], ENT_QUOTES) . '\', category_image = \'' . $upload_file . '\', category_level = \'' . $_POST['category_level'] . '\'
                                 WHERE category_id = \'' . $_POST['category_id'] . '\'');
                    success_template($lang['ADMIN_CATEGORIES_EDITED'], './../admin/advanced.php');
                }
                else
                {
                    error_template($lang['ADMIN_CATEGORIES_ERROR4']);
                }
            }
            else
            {
                $sql->query('UPDATE ' . TABLE_CATEGORIES . '
                             SET category_name = \'' . chars2entities($_POST['category_name'], ENT_QUOTES) . '\', category_image = \'' . $_POST['category_image'] . '\', category_level = \'' . $_POST['category_level'] . '\'
                             WHERE category_id = \'' . $_POST['category_id'] . '\'');
                success_template($lang['ADMIN_CATEGORIES_EDITED'], './../admin/advanced.php');
            }
        }
    }
    // Delete link
    elseif (isset($_GET['action']) && $_GET['action'] == 'delete_category')
    {
        // Check query
        if (!empty($_GET['category_id']))
        {
            $sql->query('SELECT category_image, category_news, category_posts
                         FROM ' . TABLE_CATEGORIES . '
                         WHERE category_id = \'' . $_GET['category_id'] . '\'');
            $table_categories = $sql->fetch();
            // Check category
            if (!$table_categories['category_image'])
            {
                error_template($lang['ADMIN_QUERY_ERROR']);
            }
            else
            {
                if ($table_categories['category_news'] != 0 || $table_categories['category_posts'] != 0)
                {
                    error_template($lang['ADMIN_CATEGORIES_ERROR7']);
                }
                else
                {
                    // Delete old image
                    unlink($table_categories['category_image']);
                    $sql->query('DELETE FROM ' . TABLE_CATEGORIES . '
                                 WHERE category_id = \'' . $_GET['category_id'] . '\'');
                    success_template($lang['ADMIN_CATEGORIES_DELETED'], './../admin/advanced.php');
                }
            }
        }
        else
        {
            error_template($lang['ADMIN_QUERY_ERROR']);
        }
    }
    // Add form
    else
    {
        $category_level_options = '<option value="0">' . $lang['ADMIN_CATEGORIES_LEVEL0'] . '</option><option value="1">' . $lang['ADMIN_CATEGORIES_LEVEL1'] . '</option><option value="2">' . $lang['ADMIN_CATEGORIES_LEVEL2'] . '</option><option value="3">' . $lang['ADMIN_CATEGORIES_LEVEL3'] . '</option>';
        $template->set_file('admin', 'admin/categories/add.htpl');
        $template->set_var(array('ADD' => $lang['ADD'],
                                 'ADMIN_CATEGORIES_HEADER1' => $lang['ADMIN_CATEGORIES_HEADER1'],
                                 'BACK_ADMIN_ADVANCED' => $lang['BACK_ADMIN_ADVANCED'],
                                 'CATEGORY_LEVEL_OPTIONS' => $category_level_options,
                                 'FORM_CATEGORY_IMAGE' => $lang['FORM_CATEGORY_IMAGE'],
                                 'FORM_CATEGORY_LEVEL' => $lang['FORM_CATEGORY_LEVEL'],
                                 'FORM_CATEGORY_NAME' => $lang['FORM_CATEGORY_NAME']));
        $template->parse('admin');
    }
}

page_footer();

?>