<?php
// -----------------------------------------------------------------------
//
// $Id: index.php 8 2012-01-21 09:59:39Z root $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['ADMIN_INDEX_TITLE']);

// Moderator ?
if ($users['user_level'] < 2)
{
    error_template($lang['ADMIN_INDEX_ERROR']);
}
else
{
    $sql->query('SELECT news_id
                 FROM ' . TABLE_NEWS . '
                 WHERE news_active = \'0\'');
    $num_news = $sql->num_rows();
    // Moderator ?
    if ($users['user_level'] > 1)
    {
        $medias_link = $lang['ADMIN_INDEX_LINK1'];
        $news_link = $lang['ADMIN_INDEX_LINK2'];
        if ($num_news != 0)
        {
            $news_link .= sprintf($lang['ADMIN_INDEX_LINK3'], $num_news);
        }
    }
    // Advanced moderator ?
    if ($users['user_level'] > 2)
    {
        $news_link .= $lang['ADMIN_INDEX_LINK4'];
    }
    // Administrator ?
    if ($users['user_level'] > 3)
    {
        $advanced_link = $lang['ADMIN_INDEX_LINK5'];
    }
    else
    {
        $advanced_link = $lang['ADMIN_ADVANCED_ERROR'];
    }
    $template->set_file('admin', 'admin/index.htpl');
    $template->set_var(array('ADMIN_INDEX_HEADER' => $lang['ADMIN_INDEX_HEADER'],
                             'ADMIN_IMG_ADVANCED' => $lang['ADMIN_IMG_ADVANCED'],
                             'ADMIN_IMG_MEDIAS' => $lang['ADMIN_IMG_MEDIAS'],
                             'ADMIN_IMG_NEWS' => $lang['ADMIN_IMG_NEWS'],
                             'ADVANCED_LINK' => $advanced_link,
                             'BACK_HOME' => $lang['BACK_HOME'],
                             'MEDIAS_LINK' => $medias_link,
                             'NEWS_LINK' => $news_link));
    $template->parse('admin');
}

page_footer();

?>