<?php
// -----------------------------------------------------------------------
//
// $Id: polls.php 8 2012-01-21 09:59:39Z root $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['ADMIN_INDEX_TITLE']);

// Administrator ?
if ($users['user_level'] < 4)
{
    error_template($lang['ADMIN_LEVEL_ERROR']);
}
else
{
    // From add form ?
    if (isset($_POST['add_poll']))
    {
        $error = '';
        if (!trim($_POST['question_text']))
        {
            $error .= $lang['NO_QUESTION_TEXT'];
        }
        if (!trim($_POST['answer_text']))
        {
            $error .= $lang['NO_ANSWER_TEXT'];
        }
        if ($error)
        {
            error_template($error);
        }
        else
        {
            if ($settings['allow_html'] == 0)
            {
                $question_comment = chars2entities($_POST['question_comment'], ENT_QUOTES);
            }
            else
            {
                $question_comment = do_html($_POST['question_comment']);
            }
            $question_comment = make_clickable($question_comment);
            $question_comment = do_bbcodes($question_comment);
            if ($settings['allow_smilies'] != 0)
            {
                $question_comment = do_smilies($question_comment);
            }
            $sql->query('INSERT INTO ' . TABLE_QUESTIONS . ' (question_comment, question_text)
                         VALUES (\'' . $question_comment . '\', \'' . chars2entities($_POST['question_text'], ENT_QUOTES) . '\')');
            $question_id = $sql->insert_id();
            $answer_text = explode("\n", $_POST['answer_text']);
            for ($i = 0; $i < count($answer_text); $i++)
            {
                $sql->query('INSERT INTO ' . TABLE_ANSWERS . ' (question_id, answer_text)
                             VALUES (\'' . $question_id . '\', \'' . chars2entities($answer_text[$i], ENT_QUOTES) . '\')');
            }
            success_template($lang['ADMIN_POLLS_ADDED'], './../admin/advanced.php');
        }
    }
    // Polls list
    elseif (isset($_GET['action']) && $_GET['action'] == 'edit_polls')
    {
        // Create pages list
        if (empty($_GET['page']))
        {
            $_GET['page'] = 1;
        }
        $polls_per_page = $settings['polls_per_page'];
        $polls_offset = ($_GET['page'] - 1) * $polls_per_page;
        $sql->query('SELECT question_id
                     FROM ' . TABLE_QUESTIONS);
        $num_polls = $sql->num_rows();
        $num_pages = ceil($num_polls / $polls_per_page);
        $pages_list = get_pages_list('./../admin/polls.php?action=edit_polls&amp;', $num_pages);

        $template->set_file('admin', 'admin/polls/view.htpl');
        $template->set_block('admin', 'QUESTIONS_BLOCK', 'questions');
        $sql->query('SELECT question_id, question_text
                     FROM ' . TABLE_QUESTIONS . '
                     ORDER BY question_id DESC
                     LIMIT ' . $polls_offset . ', ' . $polls_per_page);
        while ($table_questions = $sql->fetch())
        {
            $template->set_var(array('DELETE' => $lang['DELETE'],
                                     'EDIT' => $lang['EDIT'],
                                     'QUESTION_ID' => $table_questions['question_id'],
                                     'QUESTION_TEXT' => $table_questions['question_text']));
            $template->parse('QUESTIONS_BLOCK', 'questions', true);
        }
        $template->set_var(array('ADMIN_POLLS_HEADER2' => $lang['ADMIN_POLLS_HEADER2'],
                                 'ADMIN_POLLS_PAGES' => sprintf($lang['ADMIN_POLLS_PAGES'], $pages_list),
                                 'BACK_ADMIN_ADVANCED' => $lang['BACK_ADMIN_ADVANCED']));
        $template->parse('admin');
    }
    // Edit form
    elseif (isset($_GET['action']) && $_GET['action'] == 'edit_poll')
    {
        $template->set_file('admin', 'admin/polls/edit.htpl');
        $template->set_block('admin', 'ANSWERS_BLOCK', 'answers');
        $sql->query('SELECT answer_id, answer_text
                     FROM ' . TABLE_ANSWERS . '
                     WHERE question_id = \'' . $_GET['question_id'] . '\'
                     ORDER BY answer_id');
        while ($table_answers = $sql->fetch())
        {
            $template->set_var(array('ANSWER_ID' => $table_answers['answer_id'],
                                     'ANSWER_TEXT' => $table_answers['answer_text']));
            $template->parse('ANSWERS_BLOCK', 'answers', true);
        }
        $sql->query('SELECT question_comment, question_id, question_text
                     FROM ' . TABLE_QUESTIONS . '
                     WHERE question_id = \'' . $_GET['question_id'] . '\'');
        $table_questions = $sql->fetch();
        if ($settings['allow_html'] == 0)
        {
            $html_support = $lang['HTML_DISABLED'];
        }
        else
        {
            $html_support = $lang['HTML_ENABLED'];
        }
        $question_comment = undo_smilies($table_questions['question_comment']);
        $question_comment = undo_bbcodes($question_comment);
        $template->set_var(array('ADMIN_POLLS_HEADER3' => $lang['ADMIN_POLLS_HEADER3'],
                                 'BACK_ADMIN_ADVANCED' => $lang['BACK_ADMIN_ADVANCED'],
                                 'DELETE' => $lang['DELETE'],
                                 'EDIT' => $lang['EDIT'],
                                 'FORM_ANSWER_TEXT' => $lang['FORM_ANSWER_TEXT'],
                                 'FORM_QUESTION_COMMENT' => $lang['FORM_QUESTION_COMMENT'],
                                 'FORM_QUESTION_TEXT' => $lang['FORM_QUESTION_TEXT'],
                                 'HTML_SUPPORT' => $html_support,
                                 'QUESTION_COMMENT' => $question_comment,
                                 'QUESTION_ID' => $table_questions['question_id'],
                                 'QUESTION_TEXT' => $table_questions['question_text'],
                                 'SMILIES_LIST' => get_smilies_list(0)));
        $template->parse('admin');
    }
    // From edit form ?
    elseif (isset($_POST['edit_poll']))
    {
        $error = '';
        $answer_id = array_keys($_POST['answer_text']);
        $answer_text = array_values($_POST['answer_text']);
        if (!trim($_POST['question_text']))
        {
            $error .= $lang['NO_QUESTION_TEXT'];
        }
        if (isset($_POST['delete_id']))
        {
            $delete_id = array_keys($_POST['delete_id']);
            if (count($delete_id) == count($answer_text))
            {
                $error .= $lang['NO_ANSWER_TEXT'];
            }
        }
        else
        {
            for ($i = 0; $i < count($answer_text); $i++)
            {
                if (!trim($answer_text[$i]))
                {
                    $error .= $lang['NO_ANSWER_TEXT'];
                }
            }
        }
        if ($error)
        {
            error_template($error);
        }
        else
        {
            for ($i = 0; $i < count($answer_text); $i++)
            {
                if (isset($delete_id[$i]))
                {
                    $j = $votes_per_answer = 0;
                    $query = array();
                    $sql->query('SELECT COUNT(*) AS votes_per_user, user_id
                                 FROM ' . TABLE_VOTES . '
                                 WHERE answer_id = \'' . $delete_id[$i] . '\'
                                 GROUP BY user_id
                                 ORDER BY user_id');
                    while ($table_votes = $sql->fetch())
                    {
                        $votes_per_answer += $table_votes['votes_per_user'];
                        $query[$j] = 'UPDATE ' . TABLE_USERS . '
                                      SET user_votes = user_votes - ' . $table_votes['votes_per_user'] . '
                                      WHERE user_id = \'' . $table_votes['user_id'] . '\'';
                        $j++;
                    }
                    for ($k = 0; $k < $j; $k++)
                    {
                        $sql->query($query[$k]);
                    }
                    $sql->query('DELETE FROM ' . TABLE_ANSWERS . '
                                 WHERE answer_id = \'' . $delete_id[$i] . '\'');
                    $sql->query('UPDATE ' . TABLE_QUESTIONS . '
                                 SET question_votes = question_votes - ' . $votes_per_answer . '
                                 WHERE question_id = \'' . $_POST['question_id'] . '\'');
                    $sql->query('DELETE FROM ' . TABLE_VOTES . '
                                 WHERE answer_id = \'' . $delete_id[$i] . '\'');
                }
                else
                {
                    $sql->query('UPDATE ' . TABLE_ANSWERS . '
                                 SET answer_text = \'' . chars2entities($answer_text[$i], ENT_QUOTES) . '\'
                                 WHERE answer_id = \'' . $answer_id[$i] . '\'');
                }
            }
            if ($settings['allow_html'] == 0)
            {
                $question_comment = chars2entities($_POST['question_comment'], ENT_QUOTES);
            }
            else
            {
                $question_comment = do_html($_POST['question_comment']);
            }
            $question_comment = make_clickable($question_comment);
            $question_comment = do_bbcodes($question_comment);
            if ($settings['allow_smilies'] != 0)
            {
                $question_comment = do_smilies($question_comment);
            }
            $sql->query('UPDATE ' . TABLE_QUESTIONS . '
                         SET question_comment = \'' . $question_comment . '\', question_text = \'' . chars2entities($_POST['question_text'], ENT_QUOTES) . '\'
                         WHERE question_id = \'' . $_POST['question_id'] . '\'');
            success_template($lang['ADMIN_POLLS_EDITED'], './../admin/advanced.php');
        }
    }
    // Delete link
    elseif (isset($_GET['action']) && $_GET['action'] == 'delete_poll')
    {
        // Check query
        if (!empty($_GET['question_id']))
        {
            $i = 0;
            $query = array();
            $sql->query('SELECT COUNT(*) AS votes_per_user, user_id
                         FROM ' . TABLE_VOTES . '
                         WHERE question_id = \'' . $_GET['question_id'] . '\'
                         GROUP BY user_id
                         ORDER BY user_id');
            while ($table_votes = $sql->fetch())
            {
                $query[$i] = 'UPDATE ' . TABLE_USERS . '
                              SET user_votes = user_votes - ' . $table_votes['votes_per_user'] . '
                              WHERE user_id = \'' . $table_votes['user_id'] . '\'';
                $i++;
            }
            for ($j = 0; $j < $i; $j++)
            {
                $sql->query($query[$j]);
            }
            $sql->query('DELETE FROM ' . TABLE_ANSWERS . '
                         WHERE question_id = \'' . $_GET['question_id'] . '\'');
            $sql->query('DELETE FROM ' . TABLE_QUESTIONS . '
                         WHERE question_id = \'' . $_GET['question_id'] . '\'');
            $sql->query('DELETE FROM ' . TABLE_VOTES . '
                         WHERE question_id = \'' . $_GET['question_id'] . '\'');
            success_template($lang['ADMIN_POLLS_DELETED'], './../admin/advanced.php');
        }
        else
        {
            error_template($lang['ADMIN_QUERY_ERROR']);
        }
    }
    // Add form
    else
    {
        if ($settings['allow_html'] == 0)
        {
            $html_support = $lang['HTML_DISABLED'];
        }
        else
        {
            $html_support = $lang['HTML_ENABLED'];
        }
        $template->set_file('admin', 'admin/polls/add.htpl');
        $template->set_var(array('ADD' => $lang['ADD'],
                                 'ADMIN_POLLS_EXAMPLE' => $lang['ADMIN_POLLS_EXAMPLE'],
                                 'ADMIN_POLLS_HEADER1' => $lang['ADMIN_POLLS_HEADER1'],
                                 'BACK_ADMIN_ADVANCED' => $lang['BACK_ADMIN_ADVANCED'],
                                 'FORM_ANSWER_TEXT' => $lang['FORM_ANSWER_TEXT'],
                                 'FORM_QUESTION_COMMENT' => $lang['FORM_QUESTION_COMMENT'],
                                 'FORM_QUESTION_TEXT' => $lang['FORM_QUESTION_TEXT'],
                                 'HTML_SUPPORT' => $html_support,
                                 'SMILIES_LIST' => get_smilies_list(1)));
        $template->parse('admin');
    }
}

page_footer();

?>