<?php
// -----------------------------------------------------------------------
//
// $Id: settings.php 8 2012-01-21 09:59:39Z root $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['ADMIN_INDEX_TITLE']);

// Administrator ?
if ($users['user_level'] < 4)
{
    error_template($lang['ADMIN_LEVEL_ERROR']);
}
else
{
    // From edit form ?
    if (isset($_POST['edit_advanced_settings']))
    {
        $error = '';
        if (!trim($_POST['sitename']))
        {
            $error .= $lang['NO_SITENAME'];
        }
        if (!trim($_POST['siteurl']))
        {
            $error .= $lang['NO_SITEURL'];
        }
        if (!trim($_POST['sender_email']))
        {
            $error .= $lang['NO_USER_EMAIL'];
        }
        else
        {
            if (check_email($_POST['sender_email']))
            {
                $sender_email = $_POST['sender_email'];
            }
            else
            {
                $error .= $lang['INVALID_USER_EMAIL'];
            }
        }
        if (!trim($_POST['sender_name']))
        {
            $error .= $lang['NO_USER_NAME'];
        }
        if (!trim($_POST['date_format']))
        {
            $error .= $lang['NO_DATE_FORMAT'];
        }
        if (!preg_match('`^-?[0-9]{1,2}$`', $_POST['date_offset']))
        {
            $error .= $lang['NO_DATE_OFFSET'];
        }
        if ($error)
        {
            error_template($error);
        }
        else
        {
            if (!trim($_POST['news_per_page']))
            {
                $_POST['news_per_page'] = 7;
            }
            if (!trim($_POST['comments_per_page']))
            {
                $_POST['comments_per_page'] = 7;
            }
            if (!trim($_POST['headlines_per_backend']))
            {
                $_POST['headlines_per_backend'] = 7;
            }
            if (!trim($_POST['threads_per_page']))
            {
                $_POST['threads_per_page'] = 20;
            }
            if (!trim($_POST['posts_per_page']))
            {
                $_POST['posts_per_page'] = 20;
            }
            if (!trim($_POST['polls_per_page']))
            {
                $_POST['polls_per_page'] = 30;
            }
            if (!trim($_POST['users_per_page']))
            {
                $_POST['users_per_page'] = 30;
            }
            if (!trim($_POST['accounts_expiry']))
            {
                $_POST['accounts_expiry'] = 30;
            }
            if (!trim($_POST['cookies_expiry']))
            {
                $_POST['cookies_expiry'] = 30;
            }
            if (!trim($_POST['min_usernames_length']))
            {
                $_POST['min_usernames_length'] = 3;
            }
            if (!trim($_POST['min_passwords_length']))
            {
                $_POST['min_passwords_length'] = 6;
            }
            if (!trim($_POST['pages_limit']))
            {
                $_POST['pages_limit'] = 10;
            }
            if (!trim($_POST['search_limit']))
            {
                $_POST['search_limit'] = 30;
            }
            if (!trim($_POST['posts_interval']))
            {
                $_POST['posts_interval'] = 30;
            }
            if (!trim($_POST['votes_interval']))
            {
                $_POST['votes_interval'] = 1;
            }
            if (!trim($_POST['max_texts_length']))
            {
                $_POST['max_texts_length'] = 1000;
            }
            $sql->query('UPDATE ' . TABLE_SETTINGS . '
                         SET sitename = \'' . chars2entities($_POST['sitename'], ENT_QUOTES) . '\', siteurl = \'' . rtrim($_POST['siteurl'], ' /') . '\', language = \'' . $_POST['language'] . '\', language_unique = \'' . $_POST['language_unique'] . '\', template = \'' . $_POST['template'] . '\', template_unique = \'' . $_POST['template_unique'] . '\', news_per_page = \'' . $_POST['news_per_page'] . '\', comments_per_page = \'' . $_POST['comments_per_page'] . '\', headlines_per_backend = \'' . $_POST['headlines_per_backend'] . '\', threads_per_page = \'' . $_POST['threads_per_page'] . '\', posts_per_page = \'' . $_POST['posts_per_page'] . '\', polls_per_page = \'' . $_POST['polls_per_page'] . '\', users_per_page = \'' . $_POST['users_per_page'] . '\', news_order = \'' . $_POST['news_order'] . '\', allow_html = \'' . $_POST['allow_html'] . '\', allow_smilies = \'' . $_POST['allow_smilies'] . '\', submit_news = \'' . $_POST['submit_news'] . '\', send_news = \'' . $_POST['send_news'] . '\', register_users = \'' . $_POST['register_users'] . '\', sender_email = \'' . $sender_email . '\', sender_name = \'' . chars2entities($_POST['sender_name'], ENT_QUOTES) . '\', date_format = \'' . $_POST['date_format'] . '\', date_offset = \'' . $_POST['date_offset'] . '\', accounts_expiry = \'' . $_POST['accounts_expiry'] . '\', cookies_expiry = \'' . $_POST['cookies_expiry'] . '\', min_usernames_length = \'' . $_POST['min_usernames_length'] . '\', min_passwords_length = \'' . $_POST['min_passwords_length'] . '\', pages_limit = \'' . $_POST['pages_limit'] . '\', search_limit = \'' . $_POST['search_limit'] . '\', posts_interval = \'' . $_POST['posts_interval'] . '\', votes_interval = \'' . $_POST['votes_interval'] . '\', max_texts_length = \'' . $_POST['max_texts_length'] . '\'');
            make_backend_rss();
            success_template($lang['ADMIN_SETTINGS_SUCCESS'], './../admin/advanced.php');
        }
    }
    // Edit form
    else
    {
        $languages = get_languages_list();
        $templates = get_templates_list();
        $language_options = $template_options = '';
        for ($i = 0; $i < count($languages); $i++)
        {
            if ($languages[$i] != $settings['language'])
            {
                $language_options .= '<option value="' . $languages[$i] . '">' . $lang['' . strtoupper($languages[$i]) . ''] . '</option>';
            }
            else
            {
                $language_options .= '<option value="' . $languages[$i] . '" selected="selected">' . $lang['' . strtoupper($languages[$i]) . ''] . '</option>';
            }
        }
        if ($settings['language_unique'] == 0)
        {
            $language_unique_options = '<option value="0" selected="selected"></option><option value="1">' . $lang['FORM_SETTINGS_ONLY'] . '</option>';
        }
        else
        {
            $language_unique_options = '<option value="0"></option><option value="1" selected="selected">' . $lang['FORM_SETTINGS_ONLY'] . '</option>';
        }
        for ($i = 0; $i < count($templates); $i++)
        {
            if ($templates[$i] != $settings['template'])
            {
                $template_options .= '<option value="' . $templates[$i] . '">' . $templates[$i] . '</option>';
            }
            else
            {
                $template_options .= '<option value="' . $templates[$i] . '" selected="selected">' . $templates[$i] . '</option>';
            }
        }
        if ($settings['template_unique'] == 0)
        {
            $template_unique_options = '<option value="0" selected="selected"></option><option value="1">' . $lang['FORM_SETTINGS_ONLY'] . '</option>';
        }
        else
        {
            $template_unique_options = '<option value="0"></option><option value="1" selected="selected">' . $lang['FORM_SETTINGS_ONLY'] . '</option>';
        }
        if ($settings['news_order'] == 'news_date')
        {
            $news_order_options = '<option value="news_date" selected="selected">' . $lang['DATE'] . '</option><option value="news_month">' . $lang['MONTH'] . '</option><option value="news_year">' . $lang['YEAR'] . '</option>';
        }
        elseif ($settings['news_order'] == 'news_month')
        {
            $news_order_options = '<option value="news_date">' . $lang['DATE'] . '</option><option value="news_month" selected="selected">' . $lang['MONTH'] . '</option><option value="news_year">' . $lang['YEAR'] . '</option>';
        }
        else
        {
            $news_order_options = '<option value="news_date">' . $lang['DATE'] . '</option><option value="news_month">' . $lang['MONTH'] . '</option><option value="news_year" selected="selected">' . $lang['YEAR'] . '</option>';
        }
        if ($settings['allow_html'] == 0)
        {
            $allow_html_options = '<option value="1">' . $lang['YES'] . '</option><option value="0" selected="selected">' . $lang['NO'] . '</option></select>';
        }
        else
        {
            $allow_html_options = '<option value="1" selected="selected">' . $lang['YES'] . '</option><option value="0">' . $lang['NO'] . '</option></select>';
        }
        if ($settings['allow_smilies'] == 0)
        {
            $allow_smilies_options = '<option value="1">' . $lang['YES'] . '</option><option value="0" selected="selected">' . $lang['NO'] . '</option></select>';
        }
        else
        {
            $allow_smilies_options = '<option value="1" selected="selected">' . $lang['YES'] . '</option><option value="0">' . $lang['NO'] . '</option></select>';
        }
        if ($settings['submit_news'] == 0)
        {
            $submit_news_options = '<option value="1">' . $lang['YES'] . '</option><option value="0" selected="selected">' . $lang['NO'] . '</option></select>';
        }
        else
        {
            $submit_news_options = '<option value="1" selected="selected">' . $lang['YES'] . '</option><option value="0">' . $lang['NO'] . '</option></select>';
        }
        if ($settings['send_news'] == 0)
        {
            $send_news_options = '<option value="1">' . $lang['YES'] . '</option><option value="0" selected="selected">' . $lang['NO'] . '</option></select>';
        }
        else
        {
            $send_news_options = '<option value="1" selected="selected">' . $lang['YES'] . '</option><option value="0">' . $lang['NO'] . '</option></select>';
        }
        if ($settings['register_users'] == 0)
        {
            $register_users_options = '<option value="1">' . $lang['YES'] . '</option><option value="0" selected="selected">' . $lang['NO'] . '</option></select>';
        }
        else
        {
            $register_users_options = '<option value="1" selected="selected">' . $lang['YES'] . '</option><option value="0">' . $lang['NO'] . '</option></select>';
        }
        $template->set_file('admin', 'admin/settings/edit.htpl');
        $template->set_var(array('ACCOUNTS_EXPIRY' => $settings['accounts_expiry'],
                                 'ADMIN_SETTINGS_HEADER' => $lang['ADMIN_SETTINGS_HEADER'],
                                 'ALLOW_HTML_OPTIONS' => $allow_html_options,
                                 'ALLOW_SMILIES_OPTIONS' => $allow_smilies_options,
                                 'BACK_ADMIN_ADVANCED' => $lang['BACK_ADMIN_ADVANCED'],
                                 'COMMENTS_PER_PAGE' => $settings['comments_per_page'],
                                 'COOKIES_EXPIRY' => $settings['cookies_expiry'],
                                 'DATE_FORMAT' => $settings['date_format'],
                                 'DATE_OFFSET' => $settings['date_offset'],
                                 'EDIT' => $lang['EDIT'],
                                 'FORM_ACCOUNTS_EXPIRY' => $lang['FORM_ACCOUNTS_EXPIRY'],
                                 'FORM_ALLOW_HTML' => $lang['FORM_ALLOW_HTML'],
                                 'FORM_ALLOW_SMILIES' => $lang['FORM_ALLOW_SMILIES'],
                                 'FORM_COMMENTS_PER_PAGE' => $lang['FORM_COMMENTS_PER_PAGE'],
                                 'FORM_COOKIES_EXPIRY' => $lang['FORM_COOKIES_EXPIRY'],
                                 'FORM_DATE_FORMAT' => $lang['FORM_DATE_FORMAT'],
                                 'FORM_DATE_OFFSET' => $lang['FORM_DATE_OFFSET'],
                                 'FORM_HEADLINES_PER_BACKEND' => $lang['FORM_HEADLINES_PER_BACKEND'],
                                 'FORM_LANGUAGE' => $lang['FORM_LANGUAGE'],
                                 'FORM_MAX_TEXTS_LENGTH' => $lang['FORM_MAX_TEXTS_LENGTH'],
                                 'FORM_MIN_PASSWORDS_LENGTH' => $lang['FORM_MIN_PASSWORDS_LENGTH'],
                                 'FORM_MIN_USERNAMES_LENGTH' => $lang['FORM_MIN_USERNAMES_LENGTH'],
                                 'FORM_NEWS_ORDER' => $lang['FORM_NEWS_ORDER'],
                                 'FORM_NEWS_PER_PAGE' => $lang['FORM_NEWS_PER_PAGE'],
                                 'FORM_PAGES_LIMIT' => $lang['FORM_PAGES_LIMIT'],
                                 'FORM_POLLS_PER_PAGE' => $lang['FORM_POLLS_PER_PAGE'],
                                 'FORM_POSTS_INTERVAL' => $lang['FORM_POSTS_INTERVAL'],
                                 'FORM_POSTS_PER_PAGE' => $lang['FORM_POSTS_PER_PAGE'],
                                 'FORM_REGISTER_USERS' => $lang['FORM_REGISTER_USERS'],
                                 'FORM_SEARCH_LIMIT' => $lang['FORM_SEARCH_LIMIT'],
                                 'FORM_SEND_NEWS' => $lang['FORM_SEND_NEWS'],
                                 'FORM_SENDER_EMAIL' => $lang['FORM_SENDER_EMAIL'],
                                 'FORM_SENDER_NAME' => $lang['FORM_SENDER_NAME'],
                                 'FORM_SITENAME' => $lang['FORM_SITENAME'],
                                 'FORM_SITEURL' => $lang['FORM_SITEURL'],
                                 'FORM_SUBMIT_NEWS' => $lang['FORM_SUBMIT_NEWS'],
                                 'FORM_TEMPLATE' => $lang['FORM_TEMPLATE'],
                                 'FORM_THREADS_PER_PAGE' => $lang['FORM_THREADS_PER_PAGE'],
                                 'FORM_USERS_PER_PAGE' => $lang['FORM_USERS_PER_PAGE'],
                                 'FORM_VOTES_INTERVAL' => $lang['FORM_VOTES_INTERVAL'],
                                 'HEADLINES_PER_BACKEND' => $settings['headlines_per_backend'],
                                 'LANGUAGE_OPTIONS' => $language_options,
                                 'LANGUAGE_UNIQUE_OPTIONS' => $language_unique_options,
                                 'MAX_TEXTS_LENGTH' => $settings['max_texts_length'],
                                 'MIN_PASSWORDS_LENGTH' => $settings['min_passwords_length'],
                                 'MIN_USERNAMES_LENGTH' => $settings['min_usernames_length'],
                                 'NEWS_ORDER_OPTIONS' => $news_order_options,
                                 'NEWS_PER_PAGE' => $settings['news_per_page'],
                                 'PAGES_LIMIT' => $settings['pages_limit'],
                                 'POLLS_PER_PAGE' => $settings['polls_per_page'],
                                 'POSTS_INTERVAL' => $settings['posts_interval'],
                                 'POSTS_PER_PAGE' => $settings['posts_per_page'],
                                 'REGISTER_USERS_OPTIONS' => $register_users_options,
                                 'SEARCH_LIMIT' => $settings['search_limit'],
                                 'SEND_NEWS_OPTIONS' => $send_news_options,
                                 'SENDER_EMAIL' => $settings['sender_email'],
                                 'SENDER_NAME' => $settings['sender_name'],
                                 'SITENAME' => $settings['sitename'],
                                 'SITEURL' => $settings['siteurl'],
                                 'SUBMIT_NEWS_OPTIONS' => $submit_news_options,
                                 'TEMPLATE_OPTIONS' => $template_options,
                                 'TEMPLATE_UNIQUE_OPTIONS' => $template_unique_options,
                                 'THREADS_PER_PAGE' => $settings['threads_per_page'],
                                 'USERS_PER_PAGE' => $settings['users_per_page'],
                                 'VOTES_INTERVAL' => $settings['votes_interval']));
        $template->parse('admin');
    }
}

page_footer();

?>