<?php
// -----------------------------------------------------------------------
//
// $Id: smilies.php 8 2012-01-21 09:59:39Z root $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['ADMIN_INDEX_TITLE']);

// Administrator ?
if ($users['user_level'] < 4)
{
    error_template($lang['ADMIN_LEVEL_ERROR']);
}
else
{
    // From add form ?
    if (isset($_POST['add_smiley']))
    {
        $error = '';
        $upload_dir = './../images/smilies/';
        $upload_name = $_FILES['smiley_image']['name'];
        $upload_file = $upload_dir . $upload_name;
        $upload_ext = substr($upload_name, strrpos($upload_name, '.'));
        $valid_ext = array('.gif', '.GIF', '.jpg', '.JPG', '.jpeg', '.JPEG', '.png', '.PNG');
        // Check code
        if (!trim($_POST['smiley_code']))
        {
            $error .= $lang['NO_SMILEY_CODE'];
        }
        else
        {
            $sql->query('SELECT smiley_code
                         FROM ' . TABLE_SMILIES . '
                         WHERE smiley_code = \'' . $_POST['smiley_code'] . '\'');
            $table_smilies = $sql->fetch();
            // Check duplicate code
            if ($table_smilies['smiley_code'])
            {
                $error .= $lang['ADMIN_SMILIES_ERROR1'];
            }
        }
        // Check image
        if (!trim($upload_name))
        {
            $error .= $lang['NO_SMILEY_IMAGE'];
        }
        else
        {
            // Check directory permissions
            if (!is_writable($upload_dir))
            {
                $error .= sprintf($lang['ADMIN_SMILIES_ERROR2'], $upload_dir);
            }
            // Check duplicate image
            if (file_exists($upload_file))
            {
                $error .= $lang['ADMIN_SMILIES_ERROR3'];
            }
            // Check image format
            if (!in_array($upload_ext, $valid_ext))
            {
                $error .= $lang['INVALID_IMAGE_FILE'];
            }
        }
        if ($error)
        {
            error_template($error);
        }
        else
        {
            if (move_uploaded_file($_FILES['smiley_image']['tmp_name'], $upload_file))
            {
                $sql->query('INSERT INTO ' . TABLE_SMILIES . ' (smiley_code, smiley_image)
                             VALUES (\'' . $_POST['smiley_code'] . '\', \'' . $upload_file . '\')');
                success_template($lang['ADMIN_SMILIES_ADDED'], './../admin/advanced.php');
            }
            else
            {
                error_template($lang['ADMIN_SMILIES_ERROR4']);
            }
        }
    }
    // Smilies list
    elseif (isset($_GET['action']) && $_GET['action'] == 'edit_smilies')
    {
        $template->set_file('admin', 'admin/smilies/view.htpl');
        $template->set_block('admin', 'SMILIES_BLOCK', 'smilies');
        $sql->query('SELECT *
                     FROM ' . TABLE_SMILIES . '
                     ORDER BY smiley_id');
        while ($table_smilies = $sql->fetch())
        {
            $template->set_var(array('DELETE' => $lang['DELETE'],
                                     'EDIT' => $lang['EDIT'],
                                     'SMILEY_CODE' => $table_smilies['smiley_code'],
                                     'SMILEY_ID' => $table_smilies['smiley_id'],
                                     'SMILEY_IMAGE' => $table_smilies['smiley_image']));
            $template->parse('SMILIES_BLOCK', 'smilies', true);
        }
        $template->set_var(array('ADMIN_SMILIES_HEADER2' => $lang['ADMIN_SMILIES_HEADER2'],
                                 'BACK_ADMIN_ADVANCED' => $lang['BACK_ADMIN_ADVANCED']));
        $template->parse('admin');
    }
    // Edit form
    elseif (isset($_GET['action']) && $_GET['action'] == 'edit_smiley')
    {
        // Check query
        if (!empty($_GET['smiley_id']))
        {
            $sql->query('SELECT *
                         FROM ' . TABLE_SMILIES . '
                         WHERE smiley_id = \'' . $_GET['smiley_id'] . '\'');
            $table_smilies = $sql->fetch();
            // Check smiley
            if (!$table_smilies['smiley_id'])
            {
                error_template($lang['ADMIN_QUERY_ERROR']);
            }
            else
            {
                $template->set_file('admin', 'admin/smilies/edit.htpl');
                $template->set_var(array('ADMIN_SMILIES_HEADER3' => $lang['ADMIN_SMILIES_HEADER3'],
                                         'BACK_ADMIN_ADVANCED' => $lang['BACK_ADMIN_ADVANCED'],
                                         'EDIT' => $lang['EDIT'],
                                         'FORM_CURRENT_IMAGE' => $lang['FORM_CURRENT_IMAGE'],
                                         'FORM_SMILEY_CODE' => $lang['FORM_SMILEY_CODE'],
                                         'FORM_SMILEY_IMAGE' => $lang['FORM_SMILEY_IMAGE'],
                                         'SMILEY_CODE' => $table_smilies['smiley_code'],
                                         'SMILEY_ID' => $table_smilies['smiley_id'],
                                         'SMILEY_IMAGE' => $table_smilies['smiley_image']));
                $template->parse('admin');
            }
        }
        else
        {
            error_template($lang['ADMIN_QUERY_ERROR']);
        }
    }
    // From edit form ?
    elseif (isset($_POST['edit_smiley']))
    {
        $error = '';
        $upload_dir = './../images/smilies/';
        $upload_name = $_FILES['smiley_image2']['name'];
        $upload_file = $upload_dir . $upload_name;
        $upload_ext = substr($upload_name, strrpos($upload_name, '.'));
        $valid_ext = array('.gif', '.GIF', '.jpg', '.JPG', '.jpeg', '.JPEG', '.png', '.PNG');
        // Check code
        if (!trim($_POST['smiley_code']))
        {
            $error .= $lang['NO_SMILEY_CODE'];
        }
        else
        {
            $sql->query('SELECT smiley_code
                         FROM ' . TABLE_SMILIES . '
                         WHERE smiley_code = \'' . $_POST['smiley_code'] . '\'
                         AND smiley_id <> \'' . $_POST['smiley_id'] . '\'');
            $table_smilies = $sql->fetch();
            // Check duplicate code
            if ($table_smilies['smiley_code'])
            {
                $error .= $lang['ADMIN_SMILIES_ERROR1'];
            }
        }
        // Check new image
        if (!empty($upload_name))
        {
            // Check directory permissions
            if (!is_writable($upload_dir))
            {
                $error .= sprintf($lang['ADMIN_SMILIES_ERROR2'], $upload_dir);
            }
            // Check duplicate image
            if (file_exists($upload_file))
            {
                $error .= $lang['ADMIN_SMILIES_ERROR3'];
            }
            // Check image format
            if (!in_array($upload_ext, $valid_ext))
            {
                $error .= $lang['INVALID_IMAGE_FILE'];
            }
        }
        if ($error)
        {
            error_template($error);
        }
        else
        {
            // New image ?
            if (!empty($upload_name))
            {
                if (move_uploaded_file($_FILES['smiley_image2']['tmp_name'], $upload_file))
                {
                    // Delete old image
                    unlink($_POST['smiley_image']);
                    $sql->query('UPDATE ' . TABLE_SMILIES . '
                                 SET smiley_code = \'' . $_POST['smiley_code'] . '\', smiley_image = \'' . $upload_file . '\'
                                 WHERE smiley_id = \'' . $_POST['smiley_id'] . '\'');
                    success_template($lang['ADMIN_SMILIES_EDITED'], './../admin/advanced.php');
                }
                else
                {
                    error_template($lang['ADMIN_SMILIES_ERROR4']);
                }
            }
            else
            {
                $sql->query('UPDATE ' . TABLE_SMILIES . '
                             SET smiley_code = \'' . $_POST['smiley_code'] . '\', smiley_image = \'' . $_POST['smiley_image'] . '\'
                             WHERE smiley_id = \'' . $_POST['smiley_id'] . '\'');
                success_template($lang['ADMIN_SMILIES_EDITED'], './../admin/advanced.php');
            }
        }
    }
    // Delete link
    elseif (isset($_GET['action']) && $_GET['action'] == 'delete_smiley')
    {
        // Check query
        if (!empty($_GET['smiley_id']))
        {
            $sql->query('SELECT smiley_image
                         FROM ' . TABLE_SMILIES . '
                         WHERE smiley_id = \'' . $_GET['smiley_id'] . '\'');
            $table_smilies = $sql->fetch();
            // Check smiley
            if (!$table_smilies['smiley_image'])
            {
                error_template($lang['ADMIN_QUERY_ERROR']);
            }
            else
            {
                // Delete old image
                unlink($table_smilies['smiley_image']);
                $sql->query('DELETE FROM ' . TABLE_SMILIES . '
                             WHERE smiley_id = \'' . $_GET['smiley_id'] . '\'');
                success_template($lang['ADMIN_SMILIES_DELETED'], './../admin/advanced.php');
            }
        }
        else
        {
            error_template($lang['ADMIN_QUERY_ERROR']);
        }
    }
    // Add form
    else
    {
        $template->set_file('admin', 'admin/smilies/add.htpl');
        $template->set_var(array('ADD' => $lang['ADD'],
                                 'ADMIN_SMILIES_HEADER1' => $lang['ADMIN_SMILIES_HEADER1'],
                                 'BACK_ADMIN_ADVANCED' => $lang['BACK_ADMIN_ADVANCED'],
                                 'FORM_SMILEY_CODE' => $lang['FORM_SMILEY_CODE'],
                                 'FORM_SMILEY_IMAGE' => $lang['FORM_SMILEY_IMAGE']));
        $template->parse('admin');
    }
}

page_footer();

?>