<?php
// -----------------------------------------------------------------------
//
// $Id: templates.php 8 2012-01-21 09:59:39Z root $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['ADMIN_INDEX_TITLE']);

// Administrator ?
if ($users['user_level'] < 4)
{
    error_template($lang['ADMIN_LEVEL_ERROR']);
}
else
{
    // Edit form
    if (isset($_GET['action']) && $_GET['action'] == 'edit_template')
    {
        // Check query
        if (!empty($_GET['file']))
        {
            // Check file and directory
            if (!file_exists($_GET['file']) || !preg_match('`./../templates/`i', $_GET['file']))
            {
                error_template($lang['ADMIN_QUERY_ERROR']);
            }
            else
            {
                $handle = $_GET['file'];
                $fp = fopen($handle, 'r');
                $template_content = fread($fp, filesize($handle));
                fclose($fp);
                $template_content = preg_replace('`&([^;\s]+;)`', '&#38;\\1', $template_content);
                $template_content = preg_replace('`{([0-9A-Z_]+)}`', '&#123;\\1&#125;', $template_content);
                $template->set_file('admin', 'admin/templates/edit.htpl');
                $template->set_var(array('ADMIN_TEMPLATES_HEADER2' => $lang['ADMIN_TEMPLATES_HEADER2'],
                                         'BACK_ADMIN_ADVANCED' => $lang['BACK_ADMIN_ADVANCED'],
                                         'EDIT' => $lang['EDIT'],
                                         'FILE' => $_GET['file'],
                                         'FORM_TEMPLATE_CONTENT' => $lang['FORM_TEMPLATE_CONTENT'],
                                         'TEMPLATE_CONTENT' => $template_content));
                $template->parse('admin');
            }
        }
        else
        {
            error_template($lang['ADMIN_QUERY_ERROR']);
        }
    }
    // From edit form ?
    elseif (isset($_POST['edit_template']))
    {
        if (is_writable($_POST['file']))
        {
            $template_content = preg_replace('`&#123;([0-9A-Z_]+)&#125;`', '{\\1}', $_POST['template_content']);
            $fp = fopen($_POST['file'], 'w');
            flock($fp, LOCK_EX);
            fwrite($fp, stripslashes($template_content), strlen($template_content));
            flock($fp, LOCK_UN);
            fclose($fp);
            success_template($lang['ADMIN_TEMPLATES_EDITED'], './../admin/advanced.php');
        }
        else
        {
            error_template(sprintf($lang['ADMIN_TEMPLATES_ERROR'], $_POST['file']));
        }
    }
    // Templates tree
    else
    {
        $template->set_file('admin', 'admin/templates/view.htpl');
        $template->set_var(array('ADMIN_TEMPLATES_HEADER1' => $lang['ADMIN_TEMPLATES_HEADER1'],
                                 'BACK_ADMIN_ADVANCED' => $lang['BACK_ADMIN_ADVANCED'],
                                 'TEMPLATES_LIST' => get_templates_tree()));
        $template->parse('admin');
    }
}

page_footer();

?>