<?php
// -----------------------------------------------------------------------
//
// $Id: common.php 8 2012-01-21 09:59:39Z root $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

$mtime = explode(' ', microtime());
$start_time = $mtime[1] + $mtime[0];

$invalid = preg_match('`(ftp|http|www)`i', $_SERVER['QUERY_STRING']);
if ($invalid != false)
{
    exit('Invalid query string. Exiting...');
}

error_reporting(E_ALL);

define('GENU_VERSION', '2012.0');
define('TABLE_ANSWERS', 'genu_answers');
define('TABLE_CATEGORIES', 'genu_categories');
define('TABLE_COMMENTS', 'genu_comments');
define('TABLE_NEWS', 'genu_news');
define('TABLE_POSTS', 'genu_posts');
define('TABLE_QUESTIONS', 'genu_questions');
define('TABLE_SESSIONS', 'genu_sessions');
define('TABLE_SETTINGS', 'genu_settings');
define('TABLE_SMILIES', 'genu_smilies');
define('TABLE_USERS', 'genu_users');
define('TABLE_VOTES', 'genu_votes');

include('./../includes/config.php');
switch (SQL_TYPE)
{
    case 'mysql':
        include('./../includes/mysql.php');
        $sql = new mysql;
        break;
    case 'pgsql':
        include('./../includes/pgsql.php');
        $sql = new pgsql;
        break;
    case 'sqlite':
        include('./../includes/sqlite.php');
        $sql = new sqlite;
        break;
}
include('./../includes/function.php');
include('./../includes/session.php');
include('./../includes/template.php');

$sql->query('SELECT *
             FROM ' . TABLE_SETTINGS);
$settings = $sql->fetch();

// User logged ?
if ($_SESSION['user_id'] != 0)
{
    $sql->query('SELECT user_date_format, user_date_offset, user_day, user_email, user_language, user_lastvisit, user_level, user_location, user_month, user_name, user_occupation, user_template, user_viewemail, user_website, user_year
                 FROM ' . TABLE_USERS . '
                 WHERE user_id = \'' . $_SESSION['user_id'] . '\'');
    $users = $sql->fetch();
    setcookie('date_format', $users['user_date_format'], (time() + ($settings['cookies_expiry'] * 24 * 3600)), '/', '');
    setcookie('date_offset', $users['user_date_offset'], (time() + ($settings['cookies_expiry'] * 24 * 3600)), '/', '');
    setcookie('language', $users['user_language'], (time() + ($settings['cookies_expiry'] * 24 * 3600)), '/', '');
    setcookie('template', $users['user_template'], (time() + ($settings['cookies_expiry'] * 24 * 3600)), '/', '');
}

include('./../languages/' . get_language() . '.php');
$template = new template('./../templates/' . get_template());

ini_set('magic_quotes_runtime', 0);
if (get_magic_quotes_gpc())
{
    $_GET = strip_input_data($_GET);
    $_POST = strip_input_data($_POST);
    $_COOKIE = strip_input_data($_COOKIE);
}
if (SQL_TYPE != 'sqlite')
{
    $_GET = slash_input_data($_GET);
    $_POST = slash_input_data($_POST);
    $_COOKIE = slash_input_data($_COOKIE);
}

?>