<?php
// -----------------------------------------------------------------------
//
// $Id: function.php 8 2012-01-21 09:59:39Z root $
//
// Copyright (C) 2003-2012 Raoul Proença
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

function check_email($email)
{
    return preg_match('`[a-z0-9!#$%&\'*+\-/=?^_\`{|}~](\.?[a-z0-9!#$%&\'*+\-/=?^_\`{|}~])*@[a-z](-?[a-z0-9])*(\.[a-z](-?[a-z0-9])*)+`i', $email);
}

function chars2entities($str, $style)
{
    $iso_8859_2 = array(' ' => '&#160;', 'Ą' => '&#260;', '˘' => '&#728;', 'Ł' => '&#321;', '¤' => '&#164;', 'Ľ' => '&#317;', 'Ś' => '&#346;', '§' => '&#167;', '¨' => '&#168;', 'Š' => '&#352;', 'Ş' => '&#350;', 'Ť' => '&#356;', 'Ź' => '&#377;', '­' => '&#173;', 'Ž' => '&#381;', 'Ż' => '&#379;', '°' => '&#176;', 'ą' => '&#261;', '˛' => '&#731;', 'ł' => '&#322;', '´' => '&#180;', 'ľ' => '&#318;', 'ś' => '&#347;', 'ˇ' => '&#711;', '¸' => '&#184;', 'š' => '&#353;', 'ş' => '&#351;', 'ť' => '&#357;', 'ź' => '&#378;', '˝' => '&#733;', 'ž' => '&#382;', 'ż' => '&#380;', 'Ŕ' => '&#340;', 'Á' => '&#193;', 'Â' => '&#194;', 'Ă' => '&#258;', 'Ä' => '&#196;', 'Ĺ' => '&#313;', 'Ć' => '&#262;', 'Ç' => '&#199;', 'Č' => '&#268;', 'É' => '&#201;', 'Ę' => '&#280;', 'Ë' => '&#203;', 'Ě' => '&#282;', 'Í' => '&#205;', 'Î' => '&#206;', 'Ď' => '&#270;', 'Đ' => '&#272;', 'Ń' => '&#323;', 'Ň' => '&#327;', 'Ó' => '&#211;', 'Ô' => '&#212;', 'Ő' => '&#336;', 'Ö' => '&#214;', '×' => '&#215;', 'Ř' => '&#344;', 'Ů' => '&#366;', 'Ú' => '&#218;', 'Ű' => '&#368;', 'Ü' => '&#220;', 'Ý' => '&#221;', 'Ţ' => '&#354;', 'ß' => '&#223;', 'ŕ' => '&#341;', 'á' => '&#225;', 'â' => '&#226;', 'ă' => '&#259;', 'ä' => '&#228;', 'ĺ' => '&#314;', 'ć' => '&#263;', 'ç' => '&#231;', 'č' => '&#269;', 'é' => '&#233;', 'ę' => '&#281;', 'ë' => '&#235;', 'ě' => '&#283;', 'í' => '&#237;', 'î' => '&#238;', 'ď' => '&#271;', 'đ' => '&#273;', 'ń' => '&#324;', 'ň' => '&#328;', 'ó' => '&#243;', 'ô' => '&#244;', 'ő' => '&#337;', 'ö' => '&#246;', '÷' => '&#247;', 'ř' => '&#345;', 'ů' => '&#367;', 'ú' => '&#250;', 'ű' => '&#369;', 'ü' => '&#252;', 'ý' => '&#253;', 'ţ' => '&#355;', '˙' => '&#729;');
    $table = get_html_translation_table(HTML_ENTITIES, $style);
    $diff = array_diff($iso_8859_2, $table);
    $str = strtr($str, $diff);

    // HTML entities
    preg_match_all('`&[^;\s]+;`', $str, $entities, PREG_OFFSET_CAPTURE);

    $chars = '';
    $num_entities = 0;
    for ($i = 0; $i < strlen($str); $i++)
    {
        if ($str{$i} == '&')
        {
            $chars .= $str{$i};
            if (sizeof($entities[0]) != 0)
            {
                if ($entities[0][$num_entities][1] == $i)
                {
                    $num_entities++;
                }
            }
        }
        elseif ($str{$i} == ';')
        {
            $chars .= $str{$i};
            if ($num_entities > 0)
            {
                $num_entities--;
            }
        }
        else
        {
            if ($num_entities == 0)
            {
                $chars .= htmlentities($str{$i}, $style);
            }
            else
            {
                $chars .= $str{$i};
            }
        }
    }
    return $chars;
}

function close_tags($str)
{
    $tags = array('a', 'abbr', 'acronym', 'address', 'applet', 'area', 'b', 'base', 'basefont', 'bdo', 'big', 'blockquote', 'body', 'br', 'button', 'caption', 'center', 'cite', 'code', 'col', 'colgroup', 'dd', 'del', 'dfn', 'dir', 'div', 'dl', 'dt', 'em', 'fieldset', 'font', 'form', 'frame', 'frameset', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'head', 'hr', 'html', 'i', 'iframe', 'img', 'input', 'ins', 'isindex', 'kbd', 'label', 'legend', 'li', 'link', 'map', 'menu', 'meta', 'noframes', 'noscript', 'object', 'ol', 'optgroup', 'option', 'p', 'param', 'pre', 'q', 's', 'samp', 'script', 'select', 'small', 'span', 'strike', 'strong', 'style', 'sub', 'sup', 'table', 'tbody', 'td', 'textarea', 'tfoot', 'th', 'thead', 'title', 'tr', 'tt', 'u', 'ul', 'var');
    foreach ($tags as $value)
    {
        preg_match_all('`<(' . $value . ')( [^>]+)*(?<!/)>`i', $str, $opened_matches);
        preg_match_all('`</' . $value . '>`i', $str, $closed_matches);
        $num_opened = count($opened_matches[0]);
        $num_closed = count($closed_matches[0]);
        if ($num_opened > $num_closed)
        {
            for ($i = 0; $i < ($num_opened - $num_closed); $i++)
            {
                $str = $str . '</' . $opened_matches[1][$i] . '>';
            }
        }
    }
    return $str;
}

function cut_text($str, $url, $query = NULL)
{
    global $settings;

    // HTML tags stripped off, entities replaced
    $plain = preg_replace(array('`<[^>]+>`', '`&[^;\s]+;`'), array('', '*'), $str);

    if ((strlen($plain) > $settings['max_texts_length']) && empty($_GET[$query]))
    {
        $chars = '';
        $num_chars = 1;
        $num_entities = $offset = $tags = 0;

        // HTML entities
        preg_match_all('`&[^;\s]+;`', $str, $entities, PREG_OFFSET_CAPTURE);

        for ($i = 0; ; $i++)
        {
            if ($num_chars <= $settings['max_texts_length'])
            {
                $chars .= $str{$i};
                if ($str{$i} == '<')
                {
                    $tags++;
                }
                elseif ($str{$i} == '>')
                {
                    if ($tags > 0)
                    {
                        $tags--;
                    }
                }
                elseif ($str{$i} == '&')
                {
                    if (sizeof($entities[0]) != 0)
                    {
                        if ($entities[0][$num_entities][1] == $i)
                        {
                            $offset = strlen($entities[0][$num_entities][0]) - 1;
                        }
                        else
                        {
                            $num_chars++;
                        }
                    }
                }
                else
                {
                    if ($tags == 0)
                    {
                        if ($offset > 0)
                        {
                            $offset--;
                            if ($offset == 0)
                            {
                                $num_chars++;
                                $num_entities++;
                            }
                        }
                        else
                        {
                            $num_chars++;
                        }
                    }
                }
            }
            else
            {
                break;
            }
        }
        $str = $chars;
        $str = close_tags($str) . ' [<a href="' . $url . '" title="...">...</a>]';
    }
    return $str;
}

function do_bbcodes($str)
{
    preg_match_all('`\[(?!/)[^\]]+\]`', $str, $opened_matches);
    preg_match_all('`\[/[^\]]+\]`', $str, $closed_matches);
    $num_opened = count($opened_matches[0]);
    $num_closed = count($closed_matches[0]);
    $opened = array('[left]' => '<div style="text-align: left">',
                    '[right]' => '<div style="text-align: right">',
                    '[center]' => '<div style="text-align: center">',
                    '[justify]' => '<div style="text-align: justify">',
                    '[b]' => '<span style="font-weight: bold">',
                    '[i]' => '<span style="font-style: italic">',
                    '[u]' => '<span style="text-decoration: underline">',
                    '[s]' => '<span style="text-decoration: line-through">',
                    '[ol]' => '<ol>',
                    '[ul]' => '<ul>',
                    '[*]' => '<li>',
                    '[quote]' => '<div class="quoteText">');
    $closed = array('[/left]' => '</div>',
                    '[/right]' => '</div>',
                    '[/center]' => '</div>',
                    '[/justify]' => '</div>',
                    '[/b]' => '</span>',
                    '[/i]' => '</span>',
                    '[/u]' => '</span>',
                    '[/s]' => '</span>',
                    '[/color]' => '</span>',
                    '[/size]' => '</span>',
                    '[/ol]' => '</ol>',
                    '[/ul]' => '</ul>',
                    '[/*]' => '</li>',
                    '[/quote]' => '</div>',
                    '[/url]' => '</a>');
    for ($i = ($num_opened - 1); $i >= 0; $i--)
    {
        $str = preg_replace('`\[color=(#[0-9a-f]{3,6}|aqua|black|blue|fuchsia|gray|green|lime|maroon|navy|olive|purple|red|silver|teal|white|yellow)\]`ie', "'<span style=\"color: ' . strtolower('\\1') . '\">'", $str);
        $str = preg_replace('`\[size=([1-2]?[0-9](px|pt)|smaller|larger)\]`ie', "'<span style=\"font-size: ' . strtolower('\\1') . '\">'", $str);
        $str = preg_replace('`\[quote=([^\]]+)\]`', '<div class="quoteHeader">\\1</div><div class="quoteText">', $str);
        $str = preg_replace('`\[url=(\w+://[^ "\n\r\t\]]+)\]`', '<a href="\\1" title="\\1">', $str);
        $str = preg_replace('`\[img=((ht|f)tp://[^ "\n\r\t\]]+)\]`', '<img src="\\1" alt="." title="\\1" />', $str);
        $str = preg_replace('`\[email=([a-z0-9!#$%&\'*+\-/=?^_\`{|}~](\.?[a-z0-9!#$%&\'*+\-/=?^_\`{|}~])*@[a-z](-?[a-z0-9])*(\.[a-z](-?[a-z0-9])*)+)\]`i', '<a href="mailto:\\1" title="\\1">\\1</a>', $str);
        $str = preg_replace('`\[flv=(([^\]]+)\.flv)\]`', '<object type="application/x-shockwave-flash" data="./../includes/player_video.swf" width="320" height="240"><param name="movie" value="./../includes/player_video.swf" /><param name="FlashVars" value="flv=\\1&amp;configxml=./../includes/config_video.xml" /></object>', $str);
        $str = preg_replace('`\[mp3=(([^\]]+)\.mp3)\]`', '<object type="application/x-shockwave-flash" data="./../includes/player_audio.swf" width="200" height="20"><param name="movie" value="./../includes/player_audio.swf" /><param name="FlashVars" value="mp3=\\1&amp;configxml=./../includes/config_audio.xml" /></object>', $str);
        if (array_key_exists($opened_matches[0][$i], $opened))
        {
            $str = str_replace($opened_matches[0][$i], $opened[$opened_matches[0][$i]], $str);
        }
    }
    for ($j = 0; $j < $num_closed; $j++)
    {
        if (array_key_exists($closed_matches[0][$j], $closed))
        {
            $str = str_replace($closed_matches[0][$j], $closed[$closed_matches[0][$j]], $str);
        }
    }
    $str = preg_replace('`\[code\](.+)\[/code\]`esU', "'<!-- GENU_CODE_START --><div class=\"quoteCode\">' . format_code('\\1') . '</div><!-- GENU_CODE_END -->'", $str);
    return $str;
}

function do_html($str)
{
    $chars = '';
    $tags = 0;
    for ($i = 0; $i < strlen($str); $i++)
    {
        if ($str{$i} == '<')
        {
            $chars .= $str{$i};
            $tags++;
        }
        elseif ($str{$i} == '>')
        {
            $chars .= $str{$i};
            if ($tags > 0)
            {
                $tags--;
            }
        }
        else
        {
            if ($tags == 0)
            {
                $chars .= chars2entities($str{$i}, ENT_QUOTES);
            }
            else
            {
                $chars .= $str{$i};
            }
        }
    }
    return $chars;
}

function do_smilies($str)
{
    global $sql;
    $sql->query('SELECT smiley_code, smiley_image
                 FROM ' . TABLE_SMILIES);
    while ($table_smilies = $sql->fetch())
    {
        $str = str_replace($table_smilies['smiley_code'], '<img src="' . $table_smilies['smiley_image'] . '" alt="." title="' . $table_smilies['smiley_code'] . '" />', $str);
    }
    return $str;
}

function error_template($str)
{
    global $lang, $template;
    $template->set_file('error', 'error.htpl');
    $template->set_var(array('BACK_HOME' => $lang['BACK_HOME'],
                             'ERROR' => $str));
    $template->parse('error');
}

function format_code($str)
{
    // Fix double quotes escaped by backslashes in substituted backreferences (/e modifier)
    $str = str_replace('\"', '"', $str);

    $str = html_entity_decode($str, ENT_QUOTES);
    $str = stripslashes($str);
    $str = highlight_string('<?php' . $str . '?>', true);

    $str = preg_replace('`([^>&])(?=[^>]*<)`e', "chars2entities('\\1', ENT_QUOTES)", $str);
    // Fix double quotes escaped by backslashes in substituted backreferences (/e modifier)
    $str = str_replace('\&quot;', '&quot;', $str);

    // Clean highlighted string
    $search = array("\n", "\r", "\t", '&lt;?php', '?&gt;', '<code>', '</code>', '<font color="', '</font>');
    $replace = array('', '', '&nbsp;&nbsp;&nbsp;&nbsp;', '', '', '', '', '<span style="color: ', '</span>');
    $str = str_replace($search, $replace, $str);

    // Use lowercase (XHTML)
    $str = preg_replace('`(#[0-9a-f]{3,6}|aqua|black|blue|fuchsia|gray|green|lime|maroon|navy|olive|purple|red|silver|teal|white|yellow)(?=[^<]*>)`ei', "strtolower('\\0')", $str);

    // Line numbers
    $line = explode('<br />', $str);
    for ($i = 0; $i < count($line); $i++)
    {
        if ($i == 0)
        {
            $code = sprintf('<span class="codeLine">%s.&nbsp;&nbsp;</span>%s', $i + 1, $line[$i]);
        }
        else
        {
            $code .= sprintf('<br /><span class="codeLine">%s.&nbsp;&nbsp;</span>%s', $i + 1, $line[$i]);
        }
    }
    return $code;
}

function get_audios_list()
{
    global $lang;
    $array = array();
    $audios_list = '';
    $dir = './../medias/audio';
    $i = 0;
    if (is_dir($dir))
    {
        if ($handle = opendir($dir))
        {
            while (($file = readdir($handle)) !== false)
            {
                if ($file != '.' && $file != '..')
                {
                    if (is_dir($dir . '/' . $file) || preg_match('`\.mp3$`', $file))
                    {
                        $name = $dir . '/' . $file;
                        $array[$i] = '<a href="' . $name . '" style="font-family: Monospace" title="' . $file . '">' . ((strlen($file) - strlen(substr($file, strrpos($file, '.')))) > 16 ? substr($file, 0, 16) . '[...]' . substr($file, strrpos($file, '.')) : $file) . '</a> <a href="./../admin/medias.php?action=delete_media&amp;file=' . $name . '"><img src="./../images/admin/delete.png" alt="." title="' . $lang['DELETE'] . '" /></a>';
                        $i++;
                    }
                }
            }
            closedir ($handle);
        }
    }
    sort($array);
    for ($j = 0; $j < count($array); $j++)
    {
        $audios_list .= $array[$j] . '<br />';
    }
    return $audios_list;
}

function get_date_format()
{
    global $settings, $users;
    if (isset($users['user_date_format']))
    {
        $date_format = $users['user_date_format'];
    }
    elseif (isset($_COOKIE['date_format']))
    {
        $date_format = $_COOKIE['date_format'];
    }
    else
    {
        $date_format = $settings['date_format'];
    }
    return $date_format;
}

function get_date_offset()
{
    global $settings, $users;
    if (isset($users['user_date_offset']))
    {
        $date_offset = $users['user_date_offset'] * 3600;
    }
    elseif (isset($_COOKIE['date_offset']))
    {
        $date_offset = $_COOKIE['date_offset'] * 3600;
    }
    else
    {
        $date_offset = $settings['date_offset'] * 3600;
    }
    return $date_offset;
}

function get_images_list()
{
    global $lang;
    $array = array();
    $dir = './../medias/image';
    $i = 0;
    $images_list = '';
    if (is_dir($dir))
    {
        if ($handle = opendir($dir))
        {
            while (($file = readdir($handle)) !== false)
            {
                if ($file != '.' && $file != '..')
                {
                    if (is_dir($dir . '/' . $file) || preg_match('`\.(gif|jpg|jpeg|png)$`', $file))
                    {
                        $name = $dir . '/' . $file;
                        $array[$i] = '<a href="' . $name . '" style="font-family: Monospace" title="' . $file . '">' . ((strlen($file) - strlen(substr($file, strrpos($file, '.')))) > 16 ? substr($file, 0, 16) . '[...]' . substr($file, strrpos($file, '.')) : $file) . '</a> <a href="./../admin/medias.php?action=delete_media&amp;file=' . $name . '"><img src="./../images/admin/delete.png" alt="." title="' . $lang['DELETE'] . '" /></a>';
                        $i++;
                    }
                }
            }
            closedir ($handle);
        }
    }
    sort($array);
    for ($j = 0; $j < count($array); $j++)
    {
        $images_list .= $array[$j] . '<br />';
    }
    return $images_list;
}

function get_language()
{
    global $settings, $users;
    if ($settings['language_unique'] != 0)
    {
        $language = $settings['language'];
    }
    elseif (isset($users['user_language']))
    {
        $language = $users['user_language'];
    }
    elseif (isset($_COOKIE['language']))
    {
        $language = $_COOKIE['language'];
    }
    else
    {
        $language = $settings['language'];
    }
    return $language;
}

function get_languages_list()
{
    $dir = './../languages';
    $i = 0;
    $languages = array();
    if (is_dir($dir))
    {
        if ($handle = opendir($dir))
        {
            while (($file = readdir($handle)) !== false)
            {
                if (preg_match('`\.php$`', $file))
                {
                    $languages[$i] = substr($file, 0, -4);
                    $i++;
                }
            }
            closedir ($handle);
        }
    }
    sort($languages);
    return $languages;
}

function get_online_users()
{
    global $lang, $sql;
    $num_guests = $num_users = 0;
    // Sessions are updated for periods of 5 minutes. With session_expiry
    // we can detect the active users in the last 5 minutes.
    $sql->query('SELECT session_data
                 FROM ' . TABLE_SESSIONS . '
                 WHERE session_expiry > \'' . time() . '\'');
    while ($table_sessions = $sql->fetch())
    {
        if (preg_match('`user_id\|s:[1-9]{1}[0-9]*:"[1-9]{1}[0-9]*";`', $table_sessions['session_data']))
        {
            $num_users++;
        }
        else
        {
            $num_guests++;
        }
    }
    $online = sprintf($lang['HEADER_ONLINE_USERS'], $num_guests, $num_users);
    return $online;
}

function get_pages_list($str, $num_pages)
{
    global $lang, $settings;
    $pages = '';
    if (empty($_GET['list']))
    {
        $_GET['list'] = 0;
    }
    if ($_GET['page'] != 1)
    {
        if ($_GET['page'] > ($settings['pages_limit'] * $_GET['list']) + 1)
        {
            $pages .= '<a href="' . $str . 'page=' . ($_GET['page'] - 1) . '&amp;list=' . $_GET['list'] . '" title="' . $lang['PREVIOUS_PAGE'] . '">&lt;</a> ';
        }
        else
        {
            $pages .= '<a href="' . $str . 'page=' . ($_GET['page'] - 1) . '&amp;list=' . ($_GET['list'] - 1) . '" title="' . $lang['PREVIOUS_PAGE'] . '">&lt;</a> ';
        }
    }
    if ($_GET['list'] != 0)
    {
        $pages .= '<a href="' . $str . 'page=' . ($settings['pages_limit'] * $_GET['list']) . '&amp;list=' . ($_GET['list'] - 1) . '" title="' . ($settings['pages_limit'] * $_GET['list']) . '">-</a> ';
    }
    for ($current_page = ($settings['pages_limit'] * $_GET['list']) + 1; $current_page <= $settings['pages_limit'] * ($_GET['list'] + 1) && $current_page <= $num_pages; $current_page++)
    {
        if ($_GET['page'] == $current_page)
        {
            $pages .= $_GET['page'] . ' ';
        }
        else
        {
            $pages .= '<a href="' . $str . 'page=' . $current_page . '&amp;list=' . $_GET['list'] . '" title="' . $current_page . '">' . $current_page . '</a> ';
        }
    }
    if (($_GET['list'] + 1) < ($num_pages / $settings['pages_limit']))
    {
        $pages .= '<a href="' . $str . 'page=' . ($settings['pages_limit'] * ($_GET['list'] + 1) + 1) . '&amp;list=' . ($_GET['list'] + 1) . '" title="' . ($settings['pages_limit'] * ($_GET['list'] + 1) + 1) . '">+</a> ';
    }
    if (($num_pages > 1) && ($_GET['page'] != $num_pages))
    {
        if ($_GET['page'] < $settings['pages_limit'] * ($_GET['list'] + 1))
        {
            $pages .= '<a href="' . $str . 'page=' . ($_GET['page'] + 1) . '&amp;list=' . $_GET['list'] . '" title="' . $lang['NEXT_PAGE'] . '">&gt;</a> ';
        }
        else
        {
            $pages .= '<a href="' . $str . 'page=' . ($_GET['page'] + 1) . '&amp;list=' . ($_GET['list'] + 1) . '" title="' . $lang['NEXT_PAGE'] . '">&gt;</a> ';
        }
    }
    return $pages;
}

function get_smilies_list($id)
{
    global $settings, $sql;
    $smilies = '';
    $sql->query('SELECT smiley_code, smiley_image
                 FROM ' . TABLE_SMILIES);
    while ($table_smilies = $sql->fetch())
    {
        if ($settings['allow_smilies'] != 0)
        {
            $smilies .= '<img src="' . $table_smilies['smiley_image'] . '" style="cursor: pointer" alt="." title="' . $table_smilies['smiley_code'] . '" onclick="insert(\' ' . $table_smilies['smiley_code'] . ' \',\'\',' . $id . ')" />';
        }
        else
        {
            $smilies = '';
        }
    }
    return $smilies;
}

function get_template()
{
    global $settings, $users;
    if ($settings['template_unique'] != 0)
    {
        $template = $settings['template'];
    }
    elseif (isset($users['user_template']))
    {
        $template = $users['user_template'];
    }
    elseif (isset($_COOKIE['template']))
    {
        $template = $_COOKIE['template'];
    }
    else
    {
        $template = $settings['template'];

    }
    return $template;
}

function get_templates_list()
{
    $dir = './../templates';
    $i = 0;
    $templates = array();
    if (is_dir($dir))
    {
        if ($handle = opendir($dir))
        {
            while (($file = readdir($handle)) !== false)
            {
                if ($file != '.' && $file != '..')
                {
                    if (is_dir($dir . '/' . $file))
                    {
                        $templates[$i] = $file;
                        $i++;
                    }
                }
            }
            closedir ($handle);
        }
    }
    sort($templates);
    return $templates;
}

function get_templates_tree()
{
    $array = array();
    $tree = '';
    if (empty($_GET['dir']) || !preg_match('`./../templates/`i', $_GET['dir']))
    {
        $dir = './../templates';
    }
    else
    {
        $dir = $_GET['dir'];
    }
    if (is_dir($dir))
    {
        if ($handle = opendir($dir))
        {
            $previous = substr($dir, 0, (strrpos(dirname($dir . '/.'), '/')));
            if ($dir != './../templates')
            {
                $tree .= '<a href="./../admin/templates.php?dir=' . $previous . '" title="../">../</a><br />';
            }
            while (($file = readdir($handle)) !== false)
            {
                if ($file != '.' && $file != '..')
                {
                    if (is_dir($dir . '/' . $file) || preg_match('`\.(css|htpl|js)$`', $file))
                    {
                        $name = $dir . '/' . $file;
                        $array[$file] = $name;
                    }
                }
            }
            asort($array);
            for ($i = 0; $i < count($array); $i++)
            {
                $pointer = each($array);
                if (is_dir($dir . '/' . $pointer[0]))
                {
                    $tree .= '<a href="./../admin/templates.php?dir=' . $dir . '/' . $pointer[0] . '" title="' . $pointer[0] . '/">' . $pointer[0] . '/</a><br />';
                }
            }
            reset($array);
            for ($j = 0; $j < count($array); $j++)
            {
                $pointer = each($array);
                if (is_file($dir . '/' . $pointer[0]))
                {
                    $tree .= '<a href="./../admin/templates.php?action=edit_template&amp;file=' . $dir . '/' . $pointer[0] . '" title="' . $pointer[0] . '">' . $pointer[0] . '</a>&nbsp;' . filesize($dir . '/' . $pointer[0]) . ' bytes<br />';
                }
            }
            closedir ($handle);
        }
    }
    return $tree;
}

function get_videos_list()
{
    global $lang;
    $array = array();
    $dir = './../medias/video';
    $i = 0;
    $videos_list = '';
    if (is_dir($dir))
    {
        if ($handle = opendir($dir))
        {
            while (($file = readdir($handle)) !== false)
            {
                if ($file != '.' && $file != '..')
                {
                    if (is_dir($dir . '/' . $file) || preg_match('`\.flv$`', $file))
                    {
                        $name = $dir . '/' . $file;
                        $array[$i] = '<a href="' . $name . '" style="font-family: Monospace" title="' . $file . '">' . ((strlen($file) - strlen(substr($file, strrpos($file, '.')))) > 16 ? substr($file, 0, 16) . '[...]' . substr($file, strrpos($file, '.')) : $file) . '</a> <a href="./../admin/medias.php?action=delete_media&amp;file=' . $name . '"><img src="./../images/admin/delete.png" alt="." title="' . $lang['DELETE'] . '" /></a>';
                        $i++;
                    }
                }
            }
            closedir ($handle);
        }
    }
    sort($array);
    for ($j = 0; $j < count($array); $j++)
    {
        $videos_list .= $array[$j] . '<br />';
    }
    return $videos_list;
}

function make_backend_rss()
{
    global $settings, $sql;
    $rss = '<?xml version="1.0" encoding="iso-8859-1"?>' . "\n";
    $rss .= '<rss version="2.0" xmlns:atom="http://www.w3.org/2005/Atom">' . "\n";
    $rss .= '  <channel>' . "\n";
    $rss .= '    <title>' . html_entity_decode($settings['sitename'], ENT_QUOTES) . '</title>' . "\n";
    $rss .= '    <link>' . $settings['siteurl'] . '/index.php</link>' . "\n";
    $rss .= '    <atom:link href="' . $settings['siteurl'] . '/backends/backend.xml" rel="self" type="application/rss+xml" />' . "\n";
    $rss .= '    <description>RSS feed</description>' . "\n";
    $sql->query('SELECT ' . TABLE_NEWS . '.news_date, ' . TABLE_NEWS . '.news_id, ' . TABLE_NEWS . '.news_subject
                 FROM ' . TABLE_CATEGORIES . ', ' . TABLE_NEWS . '
                 WHERE ' . TABLE_CATEGORIES . '.category_id = ' . TABLE_NEWS . '.category_id
                 AND ' . TABLE_CATEGORIES . '.category_level IN (\'0\', \'2\')
                 AND ' . TABLE_NEWS . '.news_active = \'1\'
                 ORDER BY ' . TABLE_NEWS . '.news_date DESC
                 LIMIT 0, ' . $settings['headlines_per_backend']);
    while ($table_news = $sql->fetch())
    {
        $date = date('D, d M Y H:i:s \G\M\T', $table_news['news_date']);
        $rss .= '    <item>' . "\n";
        $rss .= '      <title>' . html_entity_decode($table_news['news_subject'], ENT_QUOTES) . '</title>' . "\n";
        $rss .= '      <link>' . $settings['siteurl'] . '/comments/index.php?news_id=' . $table_news['news_id'] . '</link>' . "\n";
        $rss .= '      <guid>' . $settings['siteurl'] . '/comments/index.php?news_id=' . $table_news['news_id'] . '</guid>' . "\n";
        $rss .= '      <pubDate>' . $date . '</pubDate>' . "\n";
        $rss .= '    </item>' . "\n";
    }
    $rss .= '  </channel>' . "\n";
    $rss .= '</rss>';
    if ($fp = @fopen('./../backends/backend.xml', 'w'))
    {
        flock($fp, LOCK_EX);
        fwrite($fp, $rss, strlen($rss));
        flock($fp, LOCK_UN);
        fclose($fp);
    }
}

function make_clickable($str)
{
    $str = preg_replace('`(^|[\n ])(\w+://[^ "\n\r\t\]<]+)\b`', '\\1<a href="\\2" title="\\2">\\2</a>', $str);
    $str = preg_replace('`(^|[\n ])([a-z0-9!#$%&\'*+\-/=?^_\`{|}~](\.?[a-z0-9!#$%&\'*+\-/=?^_\`{|}~])*@[a-z](-?[a-z0-9])*(\.[a-z](-?[a-z0-9])*)+)`i', '\\1<a href="mailto:\\2" title="\\2">\\2</a>', $str);
    return $str;
}

function page_footer()
{
    global $lang, $sql, $start_time, $template;
    $mtime = explode(' ', microtime());
    $end_time = $mtime[1] + $mtime[0];
    $total_time = number_format(($end_time - $start_time), 3, '.', ' ') . ' s';
    $template->set_file('footer', 'footer.htpl');
    $template->set_var(array('FOOTER_COPYRIGHT' => sprintf($lang['FOOTER_COPYRIGHT'], GENU_VERSION),
                             'FOOTER_GENERATION' => sprintf($lang['FOOTER_GENERATION'], $total_time, $sql->num_queries())));
    $template->parse('footer');
    session_write_close();
    $sql->close();
}

function page_header($page_title)
{
    global $lang, $settings, $template, $users;
    // User logged ?
    if (isset($users['user_name']))
    {
        $login_form = sprintf($lang['HEADER_LOGOUT'], $users['user_name']);
    }
    else
    {
        $login_form = $lang['HEADER_LOGIN'];
    }
    $template->set_file('header', 'header.htpl');
    $template->set_var(array('HEADER_ADMIN' => $lang['HEADER_ADMIN'],
                             'HEADER_BROWSE_NEWS' => $lang['HEADER_BROWSE_NEWS'],
                             'HEADER_FORUM' => $lang['HEADER_FORUM'],
                             'HEADER_HOME' => $lang['HEADER_HOME'],
                             'HEADER_MENU' => $lang['HEADER_MENU'],
                             'HEADER_ONLINE_USERS' => get_online_users(),
                             'HEADER_PASSWORD' => $lang['HEADER_PASSWORD'],
                             'HEADER_POLLS' => $lang['HEADER_POLLS'],
                             'HEADER_PROFILE' => $lang['HEADER_PROFILE'],
                             'HEADER_REGISTER' => $lang['HEADER_REGISTER'],
                             'HEADER_SUBMIT_NEWS' => $lang['HEADER_SUBMIT_NEWS'],
                             'HEADER_USERS' => $lang['HEADER_USERS'],
                             'LOGIN_FORM' => $login_form,
                             'PAGE_TITLE' => $page_title,
                             'SITENAME' => $settings['sitename'],
                             'TEMPLATE' => get_template()));
    $template->parse('header');
}

function slash_input_data(&$data)
{
    if (is_array($data))
    {
        foreach ($data as $k => $v)
        {
            $data[$k] = (is_array($v)) ? slash_input_data($v) : addslashes($v);
        }
    }
    return $data;
}

function strip_input_data(&$data)
{
    if (is_array($data))
    {
        foreach ($data as $k => $v)
        {
            $data[$k] = (is_array($v)) ? strip_input_data($v) : stripslashes($v);
        }
    }
    return $data;
}

function success_template($str, $url)
{
    global $lang, $template;
    $template->set_file('success', 'success.htpl');
    $template->set_var(array('CONTINUE' => $lang['CONTINUE'],
                             'SUCCESS' => $str,
                             'URL' => $url));
    $template->parse('success');
    header('Refresh: 3;URL=' . $url);
}

function undo_bbcodes($str)
{
    // Code
    preg_match_all('`<!-- GENU_CODE_START -->.+<!-- GENU_CODE_END -->`sU', $str, $matches, PREG_OFFSET_CAPTURE);
    $num_matches = count($matches[0]);
    for ($i = ($num_matches - 1); $i >= 0; $i--)
    {
        $code = $matches[0][$i][0];

        // Clean code
        $code = preg_replace('`<span class="codeLine">[^<]+`', '', $code);
        $code = preg_replace('`<span style="color:[^"]+">`', '', $code);
        $code = str_replace('</span>', '', $code);
        $code = str_replace('<br />', "\n", $code);
        $code = preg_replace('`<!-- GENU_CODE_START --><div class="quoteCode">(.+)</div><!-- GENU_CODE_END -->`sU', '[code]\\1[/code]', $code);

        // Rebuild string
        $start = substr($str, 0, $matches[0][$i][1]);
        $end = substr($str, ($matches[0][$i][1] + strlen($matches[0][$i][0])), strlen($str));
        $str = $start . $code . $end;
    }

    // Others
    preg_match_all('`<(?!/)[^>]+>`', $str, $opened_matches);
    preg_match_all('`</[^>]+>`', $str, $closed_matches);
    $num_opened = count($opened_matches[0]);
    $num_closed = count($closed_matches[0]);
    $opened = array('<ol>' => '[ol]',
                    '<ul>' => '[ul]',
                    '<li>' => '[*]');
    $closed = array('</ol>' => '[/ol]',
                    '</ul>' => '[/ul]',
                    '</li>' => '[/*]');
    for ($i = ($num_opened - 1); $i >= 0; $i--)
    {
        if (array_key_exists($opened_matches[0][$i], $opened))
        {
            $str = str_replace($opened_matches[0][$i], $opened[$opened_matches[0][$i]], $str);
        }
    }
    for ($j = 0; $j < $num_closed; $j++)
    {
        $str = preg_replace('`<div style="text-align: left">([^<]+)' . $closed_matches[0][$j] . '`', '[left]\\1[/left]', $str);
        $str = preg_replace('`<div style="text-align: right">([^<]+)' . $closed_matches[0][$j] . '`', '[right]\\1[/right]', $str);
        $str = preg_replace('`<div style="text-align: center">([^<]+)' . $closed_matches[0][$j] . '`', '[center]\\1[/center]', $str);
        $str = preg_replace('`<div style="text-align: justify">([^<]+)' . $closed_matches[0][$j] . '`', '[justify]\\1[/justify]', $str);
        $str = preg_replace('`<span style="font-weight: bold">([^<]+)' . $closed_matches[0][$j] . '`', '[b]\\1[/b]', $str);
        $str = preg_replace('`<span style="font-style: italic">([^<]+)' . $closed_matches[0][$j] . '`', '[i]\\1[/i]', $str);
        $str = preg_replace('`<span style="text-decoration: underline">([^<]+)' . $closed_matches[0][$j] . '`', '[u]\\1[/u]', $str);
        $str = preg_replace('`<span style="text-decoration: line-through">([^<]+)' . $closed_matches[0][$j] . '`', '[s]\\1[/s]', $str);
        $str = preg_replace('`<span style="color: (#[0-9a-f]{3,6}|aqua|black|blue|fuchsia|gray|green|lime|maroon|navy|olive|purple|red|silver|teal|white|yellow)">([^<]+)' . $closed_matches[0][$j] . '`', '[color=\\1]\\2[/color]', $str);
        $str = preg_replace('`<span style="font-size: ([1-2]?[0-9](px|pt)|smaller|larger)">([^<]+)' . $closed_matches[0][$j] . '`', '[size=\\1]\\3[/size]', $str);
        $str = preg_replace('`<div class="quoteHeader">([^<]+)' . $closed_matches[0][$j] . '<div class="quoteText">([^<]+)' . $closed_matches[0][$j] . '`', '[quote=\\1]\\2[/quote]', $str);
        $str = preg_replace('`<div class="quoteText">([^<]+)' . $closed_matches[0][$j] . '`', '[quote]\\1[/quote]', $str);
        $str = preg_replace('`<a href="(\w+://[^ "\n\r\t<]+)" title="\\1">([^<]+)' . $closed_matches[0][$j] . '`', '[url=\\1]\\2[/url]', $str);
        $str = preg_replace('`<img src="((ht|f)tp://[^ "\n\r\t<]+)" alt="." title="\\1" />`', '[img=\\1]', $str);
        $str = preg_replace('`<a href="mailto:([a-z0-9!#$%&\'*+\-/=?^_\`{|}~](\.?[a-z0-9!#$%&\'*+\-/=?^_\`{|}~])*@[a-z](-?[a-z0-9])*(\.[a-z](-?[a-z0-9])*)+)" title="\\1">\\1' . $closed_matches[0][$j] . '`i', '[email=\\1]', $str);
        $str = preg_replace('`<object type="application/x-shockwave-flash" data="./../includes/player_video.swf" width="320" height="240"><param name="movie" value="./../includes/player_video.swf" /><param name="FlashVars" value="flv=(([^\]]+)\.flv)&amp;configxml=./../includes/config_video.xml" /></object>`', '[flv=\\1]', $str);
        $str = preg_replace('`<object type="application/x-shockwave-flash" data="./../includes/player_audio.swf" width="200" height="20"><param name="movie" value="./../includes/player_audio.swf" /><param name="FlashVars" value="mp3=(([^\]]+)\.mp3)&amp;configxml=./../includes/config_audio.xml" /></object>`', '[mp3=\\1]', $str);
        if (array_key_exists($closed_matches[0][$j], $closed))
        {
            $str = str_replace($closed_matches[0][$j], $closed[$closed_matches[0][$j]], $str);
        }
    }
    return $str;
}

function undo_escape_sequences($str)
{
    $str = str_replace("\n", '<br />', $str);
    $str = str_replace("\r", '', $str);
    $str = str_replace("\t", '&nbsp;&nbsp;&nbsp;&nbsp;', $str);
    return $str;
}

function undo_smilies($str)
{
    global $sql;
    $sql->query('SELECT smiley_code, smiley_image
                 FROM ' . TABLE_SMILIES);
    while ($table_smilies = $sql->fetch())
    {
        $str = str_replace('<img src="' . $table_smilies['smiley_image'] . '" alt="." title="' . $table_smilies['smiley_code'] . '" />', $table_smilies['smiley_code'], $str);
    }
    return $str;
}

?>