<?php
// -----------------------------------------------------------------------
//
// $Id: upgrade.php 8 2012-01-21 09:59:39Z root $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

$invalid = preg_match('`(ftp|http|www)`i', $_SERVER['QUERY_STRING']);
if ($invalid != false)
{
    exit('Invalid query string. Exiting...');
}

error_reporting(E_ALL);

include('./../includes/config.php');
if (defined('SQL_TYPE') && defined('SQL_HOST') && defined('SQL_PORT') && defined('SQL_DATABASE') && defined('SQL_USER') && defined('SQL_PASSWORD'))
{
    switch (SQL_TYPE)
    {
        case 'mysql':
            include('./../includes/mysql.php');
            $sql = new mysql;
            break;
        case 'pgsql':
            include('./../includes/pgsql.php');
            $sql = new pgsql;
            break;
        case 'sqlite':
            include('./../includes/sqlite.php');
            $sql = new sqlite;
            break;
    }
}
include('./../includes/function.php');

ini_set('magic_quotes_runtime', 0);
if (get_magic_quotes_gpc())
{
    $_GET = strip_input_data($_GET);
    $_POST = strip_input_data($_POST);
    $_COOKIE = strip_input_data($_COOKIE);
}
if (defined('SQL_TYPE') && SQL_TYPE != 'sqlite')
{
    $_GET = slash_input_data($_GET);
    $_POST = slash_input_data($_POST);
    $_COOKIE = slash_input_data($_COOKIE);
}

$error = '';

echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
  "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
<title>GENU - Upgrade</title>
<link href="./../templates/default/style.css" type="text/css" rel="stylesheet" />
<!--[if IE 6]><link href="./../templates/default/ie6.css" type="text/css" rel="stylesheet"><![endif]-->
<!--[if IE 7]><link href="./../templates/default/ie7.css" type="text/css" rel="stylesheet"><![endif]-->
<!--[if IE 8]><link href="./../templates/default/ie8.css" type="text/css" rel="stylesheet"><![endif]-->
<meta http-equiv="content-language" content="en" />
<meta http-equiv="content-type" content="application/xhtml+xml; charset=iso-8859-1" />
</head>
<body>
<div class="pageMain">
  <div class="pageLeft">
    <div class="leftLogo"><img src="./../images/logo.png" alt="." title="GENU" /></div>
    <div class="leftTitle">Menu</div>
    <div class="leftContent">
      <ul>
        <li>Home</li>
        <li>Browse news</li>
        <li>Submit news</li>
        <li>Forum</li>
        <li>Polls</li>
        <li>Administration</li>
      </ul>
    </div>
    <div class="leftTitle">Users</div>
    <div class="leftContent">
      <ul>
        <li>Log in</li>
        <li>My profile</li>
        <li>Register</li>
        <li>Forgot password?</li>
      </ul>
    </div>
    <div class="leftContent" style="text-align: center">Currently, there are 1 guest(s) and 0 registered user(s) online.</div>
  </div>
  <div class="pageRight">';

if (isset($_GET['step']) && $_GET['step'] == 2)
{
    $handle = (defined('SQL_TYPE') && SQL_TYPE == 'sqlite') ? './../sql/2012.0-sqlite.sql' : './../sql/2012.0.sql';
    if ($fp = @fopen($handle, 'r'))
    {
        $content = fread($fp, filesize($handle));
        fclose($fp);
        preg_match_all('`(ALTER|CREATE|DROP|INSERT)[^;]+;`', $content, $matches);
        $queries = $matches[0];
        for ($i = 0; $i < count($queries); $i++)
        {
            $sql->query($queries[$i]);
        }
    }
    else
    {
        $error = 'Unable to open "' . $handle . '" file.';
    }
    if ($error)
    {
        echo '
    <div class="rightMain">' . $error . '</div>';
    }
    else
    {
        echo '
    <div class="rightMain">Tables upgraded successfully.<br /><br />The upgrade is finished, please remove the install folder from your server.<br /><br />Go to the <a href="./../index.php" title="Home">index page</a> of your website.</div>';
    }
}
else
{
    echo '
    <div class="rightMain">Welcome to GENU upgrade. You must have a working GENU 2007.x or 2009.x installation. Please read <a href="./../readme.txt" title="readme.txt">readme.txt</a> before continuing.<br /><br /><a href="./upgrade.php?step=2" title="Next step">Next step &gt;</a></div>';
}

echo '
    <div class="rightBottom">Back to home</div>
  </div>
</div>
<div class="pageBottom"><a href="http://www.gnew.fr/" title="GENU">GENU</a> 2012.0, Copyright &copy; 2003-2012 Raoul Proen&ccedil;a</div>
</body>
</html>';

?>