<?php
// -----------------------------------------------------------------------
//
// $Id: index.php 8 2012-01-21 09:59:39Z root $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['NEWS_INDEX_TITLE']);

// Query string - ?news_id=&category_id=&news_month=&news_year=&page=&list=
if (!empty($_GET['news_id']))
{
    $clause = 'WHERE ' . TABLE_NEWS . '.news_id = \'' . $_GET['news_id'] . '\'';
    $query = 'news_id=' . $_GET['news_id'];
}
if (!empty($_GET['category_id']))
{
    if (!empty($_GET['news_id']))
    {
        $clause .= ' AND ' . TABLE_NEWS . '.category_id = \'' . $_GET['category_id'] . '\'';
        $query .= '&amp;category_id=' . $_GET['category_id'];
    }
    else
    {
        $clause = 'WHERE ' . TABLE_NEWS . '.category_id = \'' . $_GET['category_id'] . '\'';
        $query = 'category_id=' . $_GET['category_id'];
    }
}
if (!empty($_GET['news_month']))
{
    if (!empty($_GET['news_id']))
    {
        $clause .= ' AND ' . TABLE_NEWS . '.news_month = \'' . $_GET['news_month'] . '\'';
        $query .= '&amp;news_month=' . $_GET['news_month'];
    }
    elseif (!empty($_GET['category_id']))
    {
        $clause .= ' AND ' . TABLE_NEWS . '.news_month = \'' . $_GET['news_month'] . '\'';
        $query .= '&amp;news_month=' . $_GET['news_month'];
    }
    else
    {
        $clause = 'WHERE ' . TABLE_NEWS . '.news_month = \'' . $_GET['news_month'] . '\'';
        $query = 'news_month=' . $_GET['news_month'];
    }
}
if (!empty($_GET['news_year']))
{
    if (!empty($_GET['news_id']))
    {
        $clause .= ' AND ' . TABLE_NEWS . '.news_year = \'' . $_GET['news_year'] . '\'';
        $query .= '&amp;news_year=' . $_GET['news_year'];
    }
    elseif (!empty($_GET['category_id']))
    {
        $clause .= ' AND ' . TABLE_NEWS . '.news_year = \'' . $_GET['news_year'] . '\'';
        $query .= '&amp;news_year=' . $_GET['news_year'];
    }
    elseif (!empty($_GET['news_month']))
    {
        $clause .= ' AND ' . TABLE_NEWS . '.news_year = \'' . $_GET['news_year'] . '\'';
        $query .= '&amp;news_year=' . $_GET['news_year'];
    }
    else
    {
        $clause = 'WHERE ' . TABLE_NEWS . '.news_year = \'' . $_GET['news_year'] . '\'';
        $query = 'news_year=' . $_GET['news_year'];
    }
}
if (empty($_GET['news_id']) && empty($_GET['category_id']) && empty($_GET['news_month']) && empty($_GET['news_year']))
{
    $clause = 'WHERE';
    $query = '';
}
else
{
    $clause .= ' AND';
    $query .= '&amp;';
}

// Pages list creation - start
if (empty($_GET['page']))
{
    $_GET['page'] = 1;
}
$news_per_page = $settings['news_per_page'];
$news_offset = ($_GET['page'] - 1) * $news_per_page;

$date_format = get_date_format();
$date_offset = get_date_offset();
$template->set_file('index', 'news/index.htpl');
$template->set_block('index', 'NEWS_BLOCK', 'news');
$sql->query('SELECT ' . TABLE_CATEGORIES . '.category_id, ' . TABLE_CATEGORIES . '.category_image, ' . TABLE_CATEGORIES . '.category_name, ' . TABLE_NEWS . '.news_comments, ' . TABLE_NEWS . '.news_date, ' . TABLE_NEWS . '.news_id, ' . TABLE_NEWS . '.news_source, ' . TABLE_NEWS . '.news_subject, ' . TABLE_NEWS . '.news_text, ' . TABLE_USERS . '.user_id, ' . TABLE_USERS . '.user_name
             FROM ' . TABLE_CATEGORIES . ', ' . TABLE_NEWS . ', ' . TABLE_USERS . '
             ' . $clause . ' ' . TABLE_CATEGORIES . '.category_id = ' . TABLE_NEWS . '.category_id
             AND ' . TABLE_CATEGORIES . '.category_level IN (\'0\', \'2\')
             AND ' . TABLE_NEWS . '.news_active = \'1\'
             AND ' . TABLE_NEWS . '.user_id = ' . TABLE_USERS . '.user_id
             ORDER BY ' . $settings['news_order'] . ' DESC
             LIMIT ' . $news_offset . ', ' . $news_per_page);
while ($table_news = $sql->fetch())
{
    $news_date = date($date_format, ($table_news['news_date'] + $date_offset));
    if ($table_news['news_source'])
    {
        $news_source = undo_escape_sequences($table_news['news_source']);
        $news_source = sprintf($lang['NEWS_INDEX_SOURCE'], $news_source);
    }
    else
    {
        $news_source = '<!-- empty -->';
    }
    $news_text = undo_escape_sequences($table_news['news_text']);
    // User logged ?
    if ($_SESSION['user_id'] != 0)
    {
        // New news since last visit
        if ($table_news['news_date'] > $users['user_lastvisit'])
        {
            $subject_class = 'newItem';
        }
        else
        {
            $subject_class = 'oldItem';
        }
    }
    else
    {
        $subject_class = 'oldItem';
    }
    $news_text = cut_text($news_text, './../news/index.php?news_id=' . $table_news['news_id'], 'news_id');
    $template->set_var(array('CATEGORY_ID' => $table_news['category_id'],
                             'CATEGORY_IMAGE' => $table_news['category_image'],
                             'CATEGORY_NAME' => $table_news['category_name'],
                             'NEWS_COMMENTS' => $table_news['news_comments'],
                             'NEWS_ID' => $table_news['news_id'],
                             'NEWS_INDEX_COMMENT' => $lang['NEWS_INDEX_COMMENT'],
                             'NEWS_INDEX_RELEASE' => sprintf($lang['NEWS_INDEX_RELEASE'], $table_news['user_id'], $table_news['user_name'], $news_date),
                             'NEWS_INDEX_SEND' => $lang['NEWS_INDEX_SEND'],
                             'NEWS_SOURCE' => $news_source,
                             'NEWS_SUBJECT' => $table_news['news_subject'],
                             'NEWS_TEXT' => $news_text,
                             'SUBJECT_CLASS' => $subject_class));
    $template->parse('NEWS_BLOCK', 'news', true);
    $news_exist = true;
}
if (isset($news_exist))
{
    // Pages list creation - end
    $sql->query('SELECT ' . TABLE_NEWS . '.news_id
                 FROM ' . TABLE_CATEGORIES . ', ' . TABLE_NEWS . '
                 ' . $clause . ' ' . TABLE_CATEGORIES . '.category_id = ' . TABLE_NEWS . '.category_id
                 AND ' . TABLE_CATEGORIES . '.category_level IN (\'0\', \'2\')
                 AND ' . TABLE_NEWS . '.news_active = \'1\'');
    $num_news = $sql->num_rows();
    $num_pages = ceil($num_news / $news_per_page);
    $pages_list = get_pages_list('./../news/index.php?' . $query, $num_pages);

    // User logged ?
    if ($_SESSION['user_id'] != 0)
    {
        $sql->query('SELECT comment_id
                     FROM ' . TABLE_COMMENTS . '
                     WHERE comment_creation > ' . $users['user_lastvisit']);
        $new_comments = $sql->num_rows();
        $sql->query('SELECT news_id
                     FROM ' . TABLE_NEWS . '
                     WHERE news_date > ' . $users['user_lastvisit'] . '
                     AND news_active = \'1\'');
        $new_news = $sql->num_rows();
        $template->set_var('NEWS_INDEX_WHATSNEW', sprintf($lang['NEWS_INDEX_WHATSNEW'], $new_news, $new_comments));
    }
    $current_date = date($date_format, (time() + $date_offset));
    $template->set_var(array('FORM_IN_SUBJECT' => $lang['FORM_IN_SUBJECT'],
                             'FORM_IN_TEXT' => $lang['FORM_IN_TEXT'],
                             'NEWS_INDEX_HEADER' => sprintf($lang['NEWS_INDEX_HEADER'], $settings['sitename'], $current_date),
                             'NEWS_INDEX_PAGES' => sprintf($lang['NEWS_INDEX_PAGES'], $pages_list),
                             'SEARCH' => $lang['SEARCH']));
    $template->parse('index');
}
else
{
    error_template($lang['NEWS_INDEX_ERROR']);
}

page_footer();

?>