<?php
// -----------------------------------------------------------------------
//
// $Id: edit.php 8 2012-01-21 09:59:39Z root $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['POSTS_EDIT_TITLE']);

// From edit form ?
if (isset($_POST['edit_post']))
{
    if (!trim($_POST['post_text']))
    {
        error_template($lang['NO_POST_TEXT']);
    }
    else
    {
        if ($settings['allow_html'] == 0)
        {
            $post_text = chars2entities($_POST['post_text'], ENT_QUOTES);
        }
        else
        {
            $post_text = do_html($_POST['post_text']);
        }
        $post_text = make_clickable($post_text);
        $post_text = do_bbcodes($post_text);
        if ($settings['allow_smilies'] != 0)
        {
            $post_text = do_smilies($post_text);
        }
        $sql->query('UPDATE ' . TABLE_POSTS . '
                     SET post_text = \'' . $post_text . '\', post_edition = \'' . time() . '\'
                     WHERE post_id = \'' . $_POST['post_id'] . '\'');
        success_template($lang['POSTS_EDIT_SUCCESS'], './../posts/read.php?category_id=' . $_POST['category_id'] . '&thread_id=' . $_POST['thread_id']);
    }
}
// Edit form
else
{
    // Check query
    if (!empty($_GET['post_id']))
    {
        $sql->query('SELECT category_id, post_active, post_subject, post_text, thread_id
                     FROM ' . TABLE_POSTS . '
                     WHERE post_id = \'' . $_GET['post_id'] . '\'
                     AND user_id = \'' . $_SESSION['user_id'] . '\'');
        $table_posts = $sql->fetch();
        // Check poster
        if (!$table_posts['category_id'])
        {
            error_template($lang['POSTS_EDIT_ERROR1']);
        }
        else
        {
            // Check if thread is closed
            if ($table_posts['post_active'] == 0)
            {
                error_template($lang['POSTS_EDIT_ERROR2']);
            }
            else
            {
                if ($settings['allow_html'] == 0)
                {
                    $html_support = $lang['HTML_DISABLED'];
                }
                else
                {
                    $html_support = $lang['HTML_ENABLED'];
                }
                $post_text = undo_smilies($table_posts['post_text']);
                $post_text = undo_bbcodes($post_text);
                $template->set_file('edit', 'posts/edit.htpl');
                $template->set_var(array('BACK_THREADS_INDEX' => $lang['BACK_THREADS_INDEX'],
                                         'CATEGORY_ID' => $table_posts['category_id'],
                                         'EDIT' => $lang['EDIT'],
                                         'FORM_POST_SUBJECT' => $lang['FORM_POST_SUBJECT'],
                                         'FORM_POST_TEXT' => $lang['FORM_POST_TEXT'],
                                         'HTML_SUPPORT' => $html_support,
                                         'POST_ID' => $_GET['post_id'],
                                         'POST_SUBJECT' => $table_posts['post_subject'],
                                         'POST_TEXT' => $post_text,
                                         'POSTS_EDIT_HEADER' => $lang['POSTS_EDIT_HEADER'],
                                         'SMILIES_LIST' => get_smilies_list(0),
                                         'THREAD_ID' => $table_posts['thread_id']));
                $template->parse('edit');
            }
        }
    }
    else
    {
        error_template($lang['POSTS_EDIT_ERROR3']);
    }
}

page_footer();

?>