<?php
// -----------------------------------------------------------------------
//
// $Id: read.php 8 2012-01-21 09:59:39Z root $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['POSTS_READ_TITLE']);

// Check query
if (!empty($_GET['category_id']) && !empty($_GET['thread_id']))
{
    // Create pages list
    if (empty($_GET['page']))
    {
        $_GET['page'] = 1;
    }
    $posts_per_page = $settings['posts_per_page'];
    $posts_offset = ($_GET['page'] - 1) * $posts_per_page;
    $sql->query('SELECT post_id
                 FROM ' . TABLE_POSTS . '
                 WHERE thread_id = \'' . $_GET['thread_id'] . '\'');
    $num_posts = $sql->num_rows();
    $num_pages = ceil($num_posts / $posts_per_page);
    $pages_list = get_pages_list('./../posts/read.php?category_id=' . $_GET['category_id'] . '&amp;thread_id=' . $_GET['thread_id'] . '&amp;', $num_pages);

    $date_format = get_date_format();
    $date_offset = get_date_offset();
    $template->set_file('read', 'posts/read.htpl');
    $template->set_block('read', 'POSTS_BLOCK', 'posts');
    $sql->query('SELECT ' . TABLE_POSTS . '.post_creation, ' . TABLE_POSTS . '.post_edition, ' . TABLE_POSTS . '.post_id, ' . TABLE_POSTS . '.post_subject, ' . TABLE_POSTS . '.post_text, ' . TABLE_USERS . '.user_id, ' . TABLE_USERS . '.user_name
                 FROM ' . TABLE_POSTS . ', ' . TABLE_USERS . '
                 WHERE ' . TABLE_POSTS . '.category_id = \'' . $_GET['category_id'] . '\'
                 AND ' . TABLE_POSTS . '.thread_id = \'' . $_GET['thread_id'] . '\'
                 AND ' . TABLE_POSTS . '.user_id = ' . TABLE_USERS . '.user_id
                 ORDER BY post_creation
                 LIMIT ' . $posts_offset . ', ' . $posts_per_page);
    while ($table_posts = $sql->fetch())
    {
        $post_creation = date($date_format, ($table_posts['post_creation'] + $date_offset));
        $post_edition = date($date_format, ($table_posts['post_edition'] + $date_offset));
        if ($table_posts['post_edition'])
        {
            $post_edition = sprintf($lang['POSTS_READ_EDITION'], $post_edition);
        }
        else
        {
            $post_edition = '';
        }
        // User logged ?
        if ($_SESSION['user_id'] != 0)
        {
            // Administrator
            if ($users['user_level'] == 4)
            {
                $posts_read_edit = '<a href="./../admin/posts.php?post_id=' . $table_posts['post_id'] . '"><img src="./../images/posts/edit.png" alt="." title="' . $lang['POSTS_READ_EDIT'] . '" /></a>';
            }
            // Poster
            elseif ($table_posts['user_id'] == $_SESSION['user_id'])
            {
                $posts_read_edit = '<a href="./../posts/edit.php?post_id=' . $table_posts['post_id'] . '"><img src="./../images/posts/edit.png" alt="." title="' . $lang['POSTS_READ_EDIT'] . '" /></a>';
            }
            else
            {
                $posts_read_edit = '';
            }
            // New posts since last visit
            if ($table_posts['post_creation'] > $users['user_lastvisit'])
            {
                $subject_class = 'newItem';
            }
            else
            {
                $subject_class = 'oldItem';
            }
        }
        else
        {
            $posts_read_edit = '';
            $subject_class = 'oldItem';
        }
        // First post
        if ($table_posts['post_id'] == $_GET['thread_id'])
        {
            $post_subject = $table_posts['post_subject'];
        }
        else
        {
            $post_subject = $lang['POSTS_READ_PREVIOUS'] . $table_posts['post_subject'];
        }
        $post_text = undo_escape_sequences($table_posts['post_text']);
        $template->set_var(array('HIDDEN_SUBJECT' => $table_posts['post_subject'],
                                 'POST_EDITION' => $post_edition,
                                 'POST_SUBJECT' => $post_subject,
                                 'POST_TEXT' => $post_text,
                                 'POSTS_READ_EDIT' => $posts_read_edit,
                                 'POSTS_READ_RELEASE' => sprintf($lang['POSTS_READ_RELEASE'], $table_posts['user_id'], $table_posts['user_name'], $post_creation),
                                 'SUBJECT_CLASS' => $subject_class));
        $template->parse('POSTS_BLOCK', 'posts', true);
        $posts_exist = true;
    }
    if (isset($posts_exist))
    {
        if ($settings['allow_html'] == 0)
        {
            $html_support = $lang['HTML_DISABLED'];
        }
        else
        {
            $html_support = $lang['HTML_ENABLED'];
        }
        $template->set_var(array('ADD' => $lang['ADD'],
                                 'BACK_CATEGORIES_INDEX' => $lang['BACK_CATEGORIES_INDEX'],
                                 'BACK_HOME' => $lang['BACK_HOME'],
                                 'BACK_THREADS_INDEX' => $lang['BACK_THREADS_INDEX'],
                                 'CATEGORY_ID' => $_GET['category_id'],
                                 'FORM_POST_TEXT' => $lang['FORM_POST_TEXT'],
                                 'HTML_SUPPORT' => $html_support,
                                 'POSTS_READ_HEADER' => $lang['POSTS_READ_HEADER'],
                                 'POSTS_READ_PAGES' => sprintf($lang['POSTS_READ_PAGES'], $pages_list),
                                 'PREVIEW' => $lang['PREVIEW'],
                                 'SMILIES_LIST' => get_smilies_list(0),
                                 'THREAD_ID' => $_GET['thread_id']));
        $template->parse('read');
    }
    else
    {
        error_template($lang['POSTS_READ_ERROR']);
    }
}
else
{
    error_template($lang['POSTS_READ_ERROR']);
}

page_footer();

?>