<?php
// -----------------------------------------------------------------------
//
// $Id: info.php 8 2012-01-21 09:59:39Z root $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['USERS_INFO_TITLE']);

// Check query
if (!empty($_GET['user_id']))
{
    $sql->query('SELECT user_comments, user_creation, user_day, user_email, user_language, user_level, user_location, user_month, user_name, user_occupation, user_posts, user_template, user_votes, user_viewemail, user_website, user_year
                 FROM ' . TABLE_USERS . '
                 WHERE user_id = \'' . $_GET['user_id'] . '\'');
    $table_users = $sql->fetch();
    // Check user
    if (!$table_users['user_name'])
    {
        error_template($lang['USERS_INFO_ERROR1']);
    }
    else
    {
        if ($table_users['user_viewemail'] == 0)
        {
            $user_email = '';
        }
        else
        {
            $user_email = make_clickable($table_users['user_email']);
        }
        $date_format = get_date_format();
        $date_offset = get_date_offset();
        $user_creation = date($date_format, ($table_users['user_creation'] + $date_offset));
        $level_list = array('0' => $lang['BANNED'],
                            '1' => $lang['PUBLIC'],
                            '2' => $lang['MODERATOR'],
                            '3' => $lang['ADVANCED_MODERATOR'],
                            '4' => $lang['ADMIN']);
        $user_level = $level_list[$table_users['user_level']];

        if ($table_users['user_day'] != 0 && $table_users['user_month'] != 0 && $table_users['user_year'] != 0)
        {
            $month_days = array(1 => 31, 3 => 31, 4 => 30, 5 => 31, 6 => 30, 7 => 31, 8 => 31, 9 => 30, 10 => 31, 11 => 30, 12 => 31);
            $num_days = $offset = 0;
            $today_day = date('j', time());
            $today_month = date('n', time());
            $today_year = date('Y', time());

            for ($i = $table_users['user_year']; $i <= $today_year; $i++)
            {
                if ((($i % 4 == 0) && ($i % 100 != 0)) || ($i % 400 == 0))
                {
                    $month_days[2][$i] = 29;
                }
                else
                {
                    $month_days[2][$i] = 28;
                }
            }
            // days between 'user_day' and end of 'user_year'?
            for ($i = $table_users['user_month']; $i <= 12; $i++)
            {
                if (!isset($first_month))
                {
                    if ($i == 2)
                    {
                        $num_days += $month_days[2][$table_users['user_year']] - $table_users['user_day'];
                    }
                    else
                    {
                        $num_days += $month_days[$i] - $table_users['user_day'];
                    }
                    $first_month = true;
                }
                else
                {
                    if ($i == 2)
                    {
                        $num_days += $month_days[2][$table_users['user_year']];
                    }
                    else
                    {
                        $num_days += $month_days[$i];
                    }
                }
            }
            // days between beginning of 'today_year' and 'today_day'?
            $j = 1;
            while ($j < $today_month)
            {
                if ($j == 2)
                {
                    $num_days += $month_days[2][$today_year];
                }
                else
                {
                    $num_days += $month_days[$j];
                }
                $j++;
            }
            $num_days += $today_day;
            // bissextile 'user_year'?
            if ($month_days[2][$table_users['user_year']] == 29)
            {
                if ($table_users['user_month'] <= 2)
                {
                    $offset += 1;
                }
            }
            // bissextile 'today_year'?
            if ($month_days[2][$today_year] == 29)
            {
                if ($table_users['user_month'] > 2)
                {
                    $offset += 1;
                }
            }
            $user_age = ($num_days / (365 + $offset)) + ($today_year - $table_users['user_year'] - 1);
        }
        else
        {
            $user_age = 0;
        }
        $template->set_file('info', 'users/info.htpl');
        $template->set_var(array('BACK_HOME' => $lang['BACK_HOME'],
                                 'FORM_USER_AGE' => $lang['FORM_USER_AGE'],
                                 'FORM_USER_COMMENTS' => $lang['FORM_USER_COMMENTS'],
                                 'FORM_USER_CREATION' => $lang['FORM_USER_CREATION'],
                                 'FORM_USER_EMAIL' => $lang['FORM_USER_EMAIL'],
                                 'FORM_USER_LANGUAGE' => $lang['FORM_USER_LANGUAGE'],
                                 'FORM_USER_LEVEL' => $lang['FORM_USER_LEVEL'],
                                 'FORM_USER_LOCATION' => $lang['FORM_USER_LOCATION'],
                                 'FORM_USER_OCCUPATION' => $lang['FORM_USER_OCCUPATION'],
                                 'FORM_USER_POSTS' => $lang['FORM_USER_POSTS'],
                                 'FORM_USER_TEMPLATE' => $lang['FORM_USER_TEMPLATE'],
                                 'FORM_USER_VOTES' => $lang['FORM_USER_VOTES'],
                                 'FORM_USER_WEBSITE' => $lang['FORM_USER_WEBSITE'],
                                 'USER_AGE' => floor($user_age),
                                 'USER_COMMENTS' => $table_users['user_comments'],
                                 'USER_CREATION' => $user_creation,
                                 'USER_EMAIL' => $user_email,
                                 'USER_LANGUAGE' => $table_users['user_language'],
                                 'USER_LEVEL' => $user_level,
                                 'USER_LOCATION' => $table_users['user_location'],
                                 'USER_OCCUPATION' => $table_users['user_occupation'],
                                 'USER_POSTS' => $table_users['user_posts'],
                                 'USER_TEMPLATE' => $table_users['user_template'],
                                 'USER_VOTES' => $table_users['user_votes'],
                                 'USER_WEBSITE' => make_clickable($table_users['user_website']),
                                 'USERS_INFO_HEADER' => sprintf($lang['USERS_INFO_HEADER'], $table_users['user_name'])));
        $template->parse('info');
    }
}
else
{
    error_template($lang['USERS_INFO_ERROR2']);
}

page_footer();

?>